
;Grundri: ver0, gkons0, varreorg, vrech
;Ansicht: ver3, akons3
;Drehen:c:gdreh
;Pfeifen Liste: pf_liste

;*****************************************************************************

;;; Definition der ProgrammPfade

;;;(setq lsp-dir "c:\\cad-data\\KLAIS\\pfeife\\neu\\")
;;;(setq dat-dir "c:\\cad-data\\KLAIS\\pfeife\\neu\\")
(setq dat-dir (getenv "klais_pfeife"))
;;;(setq dat-dir (strcat dat-dir "\\"))

;;; Definition der Tonliste

(setq tonliste 
     (quote ("C" "Cs" "D" "Ds" "E" "F" "Fs" "G" "Gs" "A" "B" "H" 
             "c" "cs" "d" "ds" "e" "f" "fs" "g" "gs" "a" "b" "h"
             "c1" "cs1" "d1" "ds1" "e1" "f1" "fs1" "g1" "gs1" "a1" "b1" "h1"
             "c2" "cs2" "d2" "ds2" "e2" "f2" "fs2" "g2" "gs2" "a2" "b2" "h2"
             "c3" "cs3" "d3" "ds3" "e3" "f3" "fs3" "g3" "gs3" "a3" "b3" "h3"
             "c4" "cs4" "d4" "ds4" "e4" "f4" "fs4" "g4" "gs4" "a4" "b4" "h4")))


;******************************************************************************




;;;VER0;;;

;*** Verarbeitung1      : Erstellung von Ton-Liste(n), in Abhngigkeit des 
;***                    : Tonablaufs und des Tonumfangs
;*** Symbole einlesen   : !(nth 7 gliste) "Startton" von (ein8)
;***                    : !(nth 8 gliste) "Endton" von (ein9)
;***                    : !(nth 4 gliste) "Tonablauf" von (ein5)
;*** Symbole ausgeben   :
;*** Ausgabewert        : 
;;;nderung 9/99 ;;;

(defun ver0 ( / tonliste1 tonliste2 tonliste3 tonliste4 cmd_echo
                listewerte1 listewerte2 listewerte3 listewerte4 antw20)
  (f-ver01)


  (setq cmd_echo (getvar "CMDECHO"))
  (setvar "CMDECHO" 0)
  (setq tonliste1 nil tonliste2 nil tonliste3 nil tonliste4 nil)
  (setq listewerte1 nil listewerte2 nil listewerte3 nil listewerte4 nil)
  (setq liste1 nil liste2 nil liste3 nil liste4 nil einpassen nil)
  (referenz)
  (zeilennr)
  (datlesen)  
  (tonabl (tonu))
  (setq tonliste1 (reverse liste1))
  (setq tonliste2 (reverse liste2))
  (setq tonliste3 (reverse liste3))
  (setq tonliste4 (reverse liste4))

;;;erstellen des strings "gstring" aus der liste "gliste"
;;;gliste wird von Dialog erzeugt
  (setq bemwert (getvar "DIMZIN"))
  (setvar "DIMZIN" 0)
  (setq gstring (strcat (substr (strcat (nth 0 gliste) "      ") 1 41)
                        (substr (strcat (nth 1 gliste) "      ") 1 7)
                        (substr (strcat (nth 2 gliste) "      ") 1 4)
                        (substr (strcat (nth 3 gliste) "      ") 1 4)
                        (substr (strcat (nth 4 gliste) "      ") 1 2)
                        (substr (strcat (rtos (nth 5 gliste) 2 1)"      ") 1 6)
                        (substr (strcat (rtos (nth 6 gliste) 2 1)"      ") 1 6)
                        (substr (strcat (nth 7 gliste) "      ") 1 4)
                        (substr (strcat (nth 8 gliste) "      ") 1 4)
                  )
  )
  (setvar "DIMZIN" bemwert)
     
;;;

  ;** Die Tonabstnde werden immer vom ges. Tonumfang berechnet, unabhngig
  ;** vom Tonablauf (cromatisch, diatonisch, Terzstellung)
  ;(absta (tonu)) 
  
  ;** Die Tonabstnde werden vom Tonumfang berechnet, in Abhngigkeit
  ;** vom Tonablauf (cromatisch, diatonisch, Terzstellung)
  (absta tonliste1) 

  (tonabl listewerte)
  (setq listewerte1 (reverse liste1))
  (setq listewerte2 (reverse liste2))
  (setq listewerte3 (reverse liste3))
  (setq listewerte4 (reverse liste4))
  
;*** Zeichnen der Pfeifen im Grundri ***


;** Grundrisskonstruktion, die Funktion gkons0 wird mit 3 Argumenten aufgerufen
;* listewerte, Liste der Werte :
;* nil,1,: Gibt den Modus fuer die Ermittlung der Einfuegepunkte der Pfeifen an
;* einpassen : wenn T dann Einpassmodus, wenn nil dann Manuellmodus sie (einp)

;** Einpassmodus oder manuell einfgen **
  ;(print listewerte1)
  ;(print (setq dli (dliste listewerte1)))
  ;(print (setq ali abliplus))
  ;;;(setq antw20 (getstring "Einfgemodus whlen, Manuell oder Einpassen, <M> :"))
  ;;;(if (= "E" (strcase antw20)) 
  ;;;  (setq einpassen (einp (dliste listewerte1) abliplus))
  ;;;)


  (cond
  
    ;** Tonablauf = 3, Terzstellung
    
    (tonliste3 (progn
                 (gkons0 listewerte1 nil einpassen) 
                 ;(gkons0 listewerte2 1 einpassen)
                 ;(gkons0 listewerte3 2 einpassen)
                 ;(gkons0 listewerte4 3 einpassen)
                ))
                
  
  
    ;** Tonablauf = 2, diatonisch
    
    (tonliste2 (progn
                 (gkons0 listewerte1 nil einpassen)
                 ;(gkons0 listewerte2 1 einpassen)
                ))
                
    ;** Tonablauf = 1, chromatisch
    
    (tonliste1 (gkons0 listewerte1 nil einpassen))
    
                
  )
  
  (setq tonliste1 nil tonliste2 nil tonliste3 nil tonliste4 nil)
  (setq listewerte1 nil listewerte2 nil listewerte3 nil listewerte4 nil)
  (setq liste1 nil liste2 nil liste3 nil liste4 nil)
  (setq listewerte nil abliste nil abliste2 nil pos4 nil pos5 nil pos6 nil)
  (setq abliplus nil einpassen nil)
  (setvar "CMDECHO" cmd_echo)

  
) 





;*** Tonumfang,  
;*** Symbole einlesen   : !(nth 7 gliste) von "Startton"
;***                    : !(nth 8 gliste) von "Endton"
;***                    : 
;*** Symbole ausgeben   : !teilliste2
;*** Ausgabewert        : Liste der gewhlten Tne

(defun tonu ( / teilliste1 teilliste2)
  (f-ver02)
  (setq teilliste1 (reverse (member (nth 7 gliste) tonliste)))
  (setq teilliste2 (reverse (member (nth 8 gliste) teilliste1)))
)





;** Tonablauf,      : Erstellt eine Liste der gewhlten Tne in der ausge
;**                 : whlten Form, d.h. chromatisch, diatonisch, Terzstellung  
;** Symbole einlesen: !(tonu) von (tonu)
;**                 : !(nth 4 gliste) "Tonablauf" von (ein5)
;**                 :
;** Symbole ausgeben: 
;** Ausgabewert     : !liste1 !liste2 !liste3 !liste4, 
;**                 : Liste mit Tonnamen (strings)
;**                 :
;**                 :

(defun tonabl (tonabl_liste / zaehler1 zahl); liste1 liste2 liste3 liste4)
  (f-ver03)
  (cond 
  
;Tonumfang = 1 , chromatisch 
  
    ((= (nth 4 gliste) "1") (setq liste1 (reverse tonabl_liste)))
    
;Tonumfang = 2 , diatonisch   
    
    ((= (nth 4 gliste) "2") 
     (progn 
       (setq zahl (1+ (fix (/ (length (tonu)) 2)))) ;1+ weil Tonumfang ungerade sein kann
       (setq zaehler1 0)
       (setq liste1 '())
       (setq liste2 '())
       (repeat zahl
         (setq liste1 (cons (nth zaehler1 tonabl_liste) liste1))
         (setq zaehler1 (1+ zaehler1))
         (setq liste2 (cons (nth zaehler1 tonabl_liste) liste2))
         (setq zaehler1 (1+ zaehler1))
       )
     )
    )
    
;Tonumfang = 3 , Terzstellung   
    
    ((= (nth 4 gliste) "3") 
     (progn 
       (setq zahl (1+ (fix (/ (length (tonu)) 4))))  ; 1+ weil Tonumfang ungerade sein kann
       (setq zaehler1 0)
       (setq liste1 '())
       (setq liste2 '())
       (setq liste3 '())
       (setq liste4 '())
       (repeat zahl
         (setq liste1 (cons (nth zaehler1 tonabl_liste) liste1))
         (setq zaehler1 (1+ zaehler1))
         (setq liste2 (cons (nth zaehler1 tonabl_liste) liste2))
         (setq zaehler1 (1+ zaehler1))
         (setq liste3 (cons (nth zaehler1 tonabl_liste) liste3))
         (setq zaehler1 (1+ zaehler1))
         (setq liste4 (cons (nth zaehler1 tonabl_liste) liste4))
         (setq zaehler1 (1+ zaehler1))
       )
     )  
    )
  )
  ;(print zahl)
  ;(princ tonabl_liste)
  ;(terpri)
  (if (car liste1) () (setq liste1 (cdr liste1))) 
  (if (car liste2) () (setq liste2 (cdr liste2))) 
  (if (car liste3) () (setq liste3 (cdr liste3))) 
  (if (car liste4) () (setq liste4 (cdr liste4))) 
  ;(print (reverse liste1))
  ;(print (reverse liste2))
  ;(print (reverse liste3))
  ;(print (reverse liste4))
  (princ)
)





;** Zeilennr        : In einer Ascii-datei wird die Zeilennummer der Zeilen
;**                 : ermittelt, wo die Tabelle beginnt und wo die Basislage
;**                 : das erste mal auftaucht.
;** Symbole einlesen: !(nth 1 gliste) "Basislage" von (einl (ein2))
;**                 : !(nth 0 gliste) "Mensurname" von (einl (ein1))
;**                 : !(nth 2 gliste) "Tonkorrektur" von (einl (ein3))
;** Symbole ausgeben:
;** Ausgabewert     : !pos4, integer, Tonkorrektur * -1
;**                 : !pos5, integer, Start-ZeilenNR zum Auslesen des Durchmessers
;**                 : !pos6, integer, Start-ZeilenNR zum Auslesen der brigen Daten

(defun zeilennr ( / datei schleife1 zaehler1 zeile start basislage basis 
                    pos1 pos2 pos3)
  (f-ver04)
  (setq datei (open (strcat dat-dir (nth 0 gliste) ".dat") "r"))
  (setq basis (nth 1 gliste))
  
;** Das "," der Basislage wird durch ein " " ersetzt um mit der Schreibweise
;** in der Tabellen uebereinzustimmen.

  (cond
    ((= (substr basis 2 1) ",") 
     (setq basis (strcat (substr basis 1 1) " " (substr basis 3 3) " "))
    )
    ((= (substr basis 3 1) ",") 
     (setq basis (strcat (substr basis 1 2) " " (substr basis 4 3)))
    )    
    (T (setq basis (substr (strcat basis "      ") 1 6))
    )
  )
  ;(princ datei)
  ;(princ basis)
  (terpri)
  (setq schleife1 T)
  (setq zaehler1 1)
  (while schleife1
    (setq zeile (read-line datei))
    ;(print zaehler1)
    ;(print zeile)
    
;** Beginn der Tabelle, in der Zeile vor dem Beginn steht ein ";"

    (setq start (substr zeile 1 1))
    (setq basislage (substr zeile 4 6))
    (cond
      ((null zeile) (dateiende))
      ((= basislage basis)      ;*** Bedingung fr Pos2
        (progn
          (setq pos2 zaehler1)
          (setq schleife1 nil)
        )
      )
      ((= start ";") (setq pos1 (1+ zaehler1)))        ;*** Bedingung fr Pos1
    )
    (setq zaehler1 (1+ zaehler1))
  ) 
  (setq pos3 (- 73 (length (member (nth 7 gliste) tonliste))))
  (setq pos4 (atoi (nth 2 gliste)))
  (setq pos4 (* pos4 -1))       ;*** Vorzeichenumkehrung da in der Tabelle die 
                                ;*** Groendurchmesser zuerst stehen
  (setq pos5 (1- (+ pos2 pos3 pos4)))
  (setq pos6 (1- (+ pos2 pos3)))
  (if (< pos5 pos1) 
    (progn
      (print "Wert des Pfeifenquerschnittes nicht in der Tabelle !!!  ")
      (print "Neue Werte - Eingabe  ")
      (terpri)
      (einl)
      (zeilennr)
    )
    (progn
      ;(print pos1)
      ;(print pos2)
      ;(print pos3)
      ;(print pos4)
      ;(print pos5)
      ;(print pos6)
      (princ)
    )
  )
(close datei)
)

 (defun dateiende ()
   (princ "\nDatei-Ende erreicht ....")
   (setq schleife1 nil)
 )




;** datlesen        : In Abhngigkeit von der Tonkorrektur werden Listen er-
;** : zeugt. Wenn Tonkorrektur=0 wird 1 Liste erzeugt, die die Tabellenwerte
;** : der Tne enthlt. Wenn Tonkorrektur/=0 werden 2 Listen erzeugt. Eine fr
;** : die Durchmesser und eine fr die brigen Tabellenwerte der Tne.
;** : Ausgelesen wird nach den in (zeilennr) ermittelten Startzeilen der 
;** : Tabelle.
;** : 
;** Symbole einlesen: !(nth 0 gliste) "Mensurname" von (einl (ein1))
;**                 : !pos4, integer, Wert von Tonkorrektur mit umgekehrtem Vorzeichen
;**                 : !pos5, integer, Start-ZeilenNR zum Auslesen des Durchmessers
;**                 : !pos6, integer, Start-ZeilenNR zum Auslesen der brigen Daten
;** Symbole ausgeben: !listewerte, Liste die das Attribut "WERTE" in der Grund-
;**                 : rikonstruktion fllt.
;** Ausgabewert     : 
;**                 : 

(defun datlesen (/ );datei zaehler1 werte3 werteges zeilenzahl werteliste dim_zin
                   ;werteliste1 werteliste2 tliste labiumb string string1)
                   
  (f-ver05)
  (setq dim_zin (getvar "DIMZIN"))                   
  (setvar "DIMZIN" 0)
  (setq tliste (tonu))
  (setq zeilenzahl (length tliste))
  ;(setq zeilenzahl (length (tonu)))
  (setq zaehler1 0)
  (setq werteliste '())   
  (setq werteliste1 '())    
  (setq werteliste2 '())    
  (setq labiumb (nth 3 gliste))
  (cond
    ((= "1/3" labiumb) (setq labiumb (/ 1 3.0)))
    ((= "2/7" labiumb) (setq labiumb (/ 2 7.0)))
    ((= "1/4" labiumb) (setq labiumb (/ 1 4.0)))
    ((= "4/17" labiumb) (setq labiumb (/ 4 17.0)))
    ((= "2/9" labiumb) (setq labiumb (/ 2 9.0)))
    ((= "1/5" labiumb) (setq labiumb (/ 1 5.0)))
    ((= "0" labiumb) (setq labiumb 0.0))
  )
(setq datei (open (strcat dat-dir (nth 0 gliste) ".dat") "r"))

;** Tonkorrektur = 0

  (if (= pos5 pos6)
    (progn
      (repeat (1- pos5) (read-line datei))
      (repeat zeilenzahl 
        ;** Durchmesser, Pfeifentiefe, Krperlnge aus Tabelle
;;;        (setq werteges (substr (read-line datei) 11 16))
;** Durchmesser, Pfeifentiefe, Krperlnge,Holzstrke,Vorschlag,Seitenbart,Fudurchmesser, Fubreite
        (setq werteges (substr (read-line datei) 11 43))
        (setq string1 (substr (strcat (nth zaehler1 tliste) "    ") 1 4))
        ;(setq string1 (substr (strcat (nth zaehler1 (tonu)) "    ") 1 4))
        (setq string (rtos (* labiumb (atof (substr werteges 1 5)) pi) 2 1))
        (setq werteliste (cons(strcat string1 werteges " " string) werteliste))
        (setq zaehler1 (1+ zaehler1))
      )
    )
    (progn 

;** Tonkorrektur (Wert < 0), (-12 bis -1)   

      (if (> pos4 0)
        (progn
          (setq zaehler1 1)
          (repeat (1- (min pos5 pos6)) (read-line datei))
          (repeat (+ (abs pos4) zeilenzahl)
            (setq werteges (read-line datei))
            ;(print werteges)
            ;;;(setq werte3 (substr werteges 11 11))
            (setq werte3 (substr werteges 11 53))
            ;(print werte3)
            (if (<= zaehler1  zeilenzahl)
              (setq werteliste1 (cons werteges werteliste1))
            )
            (if (> zaehler1 (abs pos4))
              (setq werteliste2 (cons werte3 werteliste2))
            )
            (setq zaehler1 (1+ zaehler1))
          )
        )
      
;** Tonkorrektur (Wert > 0), (+12 bis +1)   
      
        (progn 
          (setq zaehler1 1)
          (repeat (1- (min pos5 pos6)) (read-line datei))
          (repeat (+ (abs pos4) zeilenzahl)
            (setq werteges (read-line datei))
            ;(print werteges)
;;;            (setq werte3 (substr werteges 11 11))
            (setq werte3 (substr werteges 11 53))
            ;(print werte3)
            (if (> zaehler1 (abs pos4))         
              (setq werteliste1 (cons werteges werteliste1))
            )
            (if (<= zaehler1  zeilenzahl)
              (setq werteliste2 (cons werte3 werteliste2))
            )
            (setq zaehler1 (1+ zaehler1))
          )
        )
      )
    )
  )
  (setq werteliste (reverse werteliste))
  (setq werteliste1 (reverse werteliste1))
  (setq werteliste2 (reverse werteliste2))
  ;(print werteliste1)
  ;(print werteliste2)
  ;(print (nth 0 werteliste))
  ;(print (last werteliste))
  ;(print (nth 0 werteliste1))
  ;(print (last werteliste1))
  ;(print (nth 0 werteliste2))
  ;(print (last werteliste2))
    
  (close datei)
  
;** Erzeugen der Eingabeliste fr das EED "WERTE" in der  Grundri-
;** konstruktion. 

  (if (null werteliste) (setq werteliste (datord)))
  (setq listewerte werteliste)
  (setvar "DIMZIN" dim_zin) 
  
;** alter Standort (einp)
)

;** datord          : Aus den in (datlesen) erzeugten 2 Liste wird 1 Liste
;** : gemacht. Diese Liste enthlt die Erzeugen von Strings, die die Tabellenwerte der Pfeifen
;** : enthalten in Abhngigkeit von Tonkorrektur u. Tonumfang. D
;**                 
;** Symbole einlesen: !(tonu), Liste der Tne im Tonumfang von (tonu)
;**                 : !werteliste2, Liste von Tab-zeilen (datlesen)
;**                 : !werteliste1, Liste von Tab-zeilenelementen (datlesen)
;** Symbole ausgeben:
;** Ausgabewert     : !werteliste3, Liste der Strings fr die bergabe an das
;**                 : EED- "WERTE" der Pfeifen im Grundri.

(defun datord (/ zaehler1 werteliste3 string1 string2 string3 string4 stringneu
                 tliste)
  (f-ver06)
  (setq zaehler1 0)
  (setq werteliste3 '())
  (setq tliste (tonu))

;;;  (repeat (length (tonu))
  (repeat (length tliste)     
    (setq string1 (nth zaehler1 tliste))
    ;(setq string1 (nth zaehler1 (tonu)))
    ;(setq string2 (nth zaehler1 werteliste2))
    (setq string2 (substr (nth zaehler1 werteliste2) 1 11))
    (setq string31 (substr (nth zaehler1 werteliste1) 23 5))
    (setq string32 (substr (nth zaehler1 werteliste2) 17 28))
    (setq string3 (strcat string31 string32))
;;;    (setq string3 (substr (nth zaehler1 werteliste1) 23 4))
    (setq string4 (rtos (* labiumb (atof string2) pi) 2 1))
;;;Auffllen mit Leerzeichen des Tonnamen je nach Lnge des Tonnamen     
    (cond 
      ((= (strlen string1) 3) (setq stringneu (strcat string1 " " string2 " " string3 " " string4)))
      ((= (strlen string1) 2) (setq stringneu (strcat string1 " " " " string2 " " string3 " " string4)))
      ((= (strlen string1) 1) (setq stringneu (strcat string1 " " " " " " string2 " " string3 " " string4)))
    )
;   (setq stringneu (strcat string1 " " string2 " " string3 " " string4))
    (setq werteliste3 (cons stringneu werteliste3))
    (setq zaehler1 (1+ zaehler1))
  )
  ;(break)
  (setq werteliste3 (reverse werteliste3))
    ;(print string1)
    ;(print string2)
    ;(print string3)
    ;(print string4)
    ;(print labiumb)
    ;(print stringneu)
    ;(print werteliste3)
)


;** absta          : Der Abstand der Pfeifen im Grundri wird berechnet. 
;**                 
;** Symbole einlesen: !(nth 5 gliste), real, Startabstand
;**                 : !(nth 6 gliste), real, Endabstand
;**                 :
;** Symbole ausgeben: !abliste, !abliplus
;** Ausgabewert     : Liste der Abstnde der Pfeifen im Grundri. Die Werte
;**                 : sind real-zahlen mit 1 Nachkommastelle
;**                 : !abliplus, wie !abliste + 2. Aussenabstand

(defun absta (tliste / zahl startab endab abstand zaehler1 zaehler2)
  (f-ver07)
  (setq zahl (length tliste))
  (setq startab (float (nth 5 gliste)))
  (setq endab (float (nth 6 gliste)))
  (setq abstand startab)
  (setq abliste (list startab))
  (setq zaehler2 (- zahl 2));** Anzahl der zu errechnenden Abstaende
  ;(setq zaehler1 (- zahl 2))
  (setq zaehler1 (- zahl 1));** es wird zusaetzlich der naechstfolgende Abstand
  (repeat zaehler1          ;** mit berechnet, als 2. Aussenabstand fuer die 
    (if (or (= startab 0) (= endab 0))   ;** Einpass-Funktion
      (setq abstand 0)
      (setq abstand (/ abstand (exp (/ (log (/ startab endab)) zaehler2))))
    )
    (setq abliste (cons (rund abstand 1) abliste))
  )
  (setq abliplus (reverse abliste)) ;** Abstandsliste + 2. Aussenabstand
  (setq abliste (reverse (cdr abliste))) ;** um die normale Abstandsliste zu
                        ;** erhalten wird der ueberzaehlige wieder abgezogen
)


;** dliste          : Die Durchm. der Pfeifen unter Bercksichtigung 
;**                 : von Tonkorrektur und Tonablauf werden aus der Liste, die
;**                 : von (datlesen) erzeugt wird extrahiert, zur bergabe an 
;**                 : die Funktion (einp)
;** Symbole einlesen: listewerte , Liste aller Werte der Pfeifen aus datlesen
;**                 : 
;**                 :
;** Symbole ausgeben: 
;** Ausgabewert     : Liste, Durchmesser der Pfeifen des Tonablaufes mit den
;**                 : grten Durchmessern, d.h. die 1. Reihe Pfeifen


(defun dliste (gesli / zahl zaehler1 dpfeife dmliste)
  (setq zahl (length gesli))
  (setq zaehler1 0)
  (setq dmliste '())
  (repeat zahl
    (setq dpfeife (substr (nth zaehler1 gesli) 5 5))
    (setq dmliste (cons dpfeife dmliste))
    (setq zaehler1 (1+ zaehler1))
  )
  (setq dmliste (reverse dmliste))
)





;** Schaltet die Generierung der Objektreferenzen ein

(defun referenz ()
  (if (= 0 (getvar "HANDLES"))
    (command "referenz" "ein")
  )
)




(defun  f-ver01 ()

  (setq alterror *error*)
;
 (defun-q *error* (st)
   ;(command "_undo" "e")
   ;(setvar "osmode" 0)
   (princ (strcat "**** FEHLER in ver0 ****  " st))
   (varreorg) (redraw)
   (setq *error* nil)
   (princ)
 )
)


(defun f-ver02 ()

  (setq alterror *error*)
;
 (defun-q *error* (st)
   ;(command "_undo" "e")
   ;(setvar "osmode" 0)
   (princ (strcat "**** FEHLER in ver0, ver02
   tonu ****  " st))
   (varreorg) (redraw)
   (setq *error* nil)
   (princ)
 )
)


(defun f-ver03 ()

  (setq alterror *error*)
;
 (defun-q *error* (st)
   ;(command "_undo" "e")
   ;(setvar "osmode" 0)
   (princ (strcat "**** FEHLER in ver0, tonabl ****  " st))
   (varreorg) (redraw)
   (setq *error* nil)
   (princ)
 )
)


(defun f-ver04 ()

  (setq alterror *error*)
;
 (defun-q *error* (st)
   ;(command "_undo" "e")
   ;(setvar "osmode" 0)
   (princ (strcat "**** FEHLER in ver0, zeilennr ****  " st))
   (varreorg) (redraw)
   (setq *error* nil)
   (princ)
 )
)


(defun f-ver05 ()

  (setq alterror *error*)
;
 (defun-q *error* (st)
   ;(command "_undo" "e")
   ;(setvar "osmode" 0)
   (princ (strcat "**** FEHLER in ver0, datlesen ****  " st))
   (varreorg) (redraw)
   (setq *error* nil)
   (princ)
 )
)


(defun f-ver06 ()

  (setq alterror *error*)
;
 (defun-q *error* (st)
   ;(command "_undo" "e")
   ;(setvar "osmode" 0)
   (princ (strcat "**** FEHLER in ver0, datord ****  " st))
   (varreorg) (redraw)
   (setq *error* nil)
   (princ)
 )
)


(defun f-ver07 ()

  (setq alterror *error*)
;
 (defun-q *error* (st)
   ;(command "_undo" "e")
   ;(setvar "osmode" 0)
   (princ (strcat "**** FEHLER in ver0, absta ****  " st))
   (varreorg) (redraw)
   (setq *error* nil)
   (princ)
 )
)

;************************************************************************************
;************************************************************************************
;************************************************************************************

;** GKONS0          : Grundrisskonstruktion 

;** Mit den Eingaben aus (einl) den erechneten Werten aus (ver1) werden die 
;** Pfeifen im Grundriss gezeichnet. Die Pfeife besteht aus Kontur,
;** Labiumstrich, EED-Daten in der Kontur "werte", "eingabe",
;** Mittelkreuz - 2 Linien  und Text - Tonname.
;** bergeben wird eine Liste mit den Daten der gewhlten Pfeifen und ein 
;** Kennzeichen fr den Tonablauf. 
;**
;** Aufruf-Argumente: liste, tonablauf  
;** Symbole einlesen: abliste von ver0 Liste der Abstaende zwischen den Toenen
;***                : neuabliste von ver0 
;***                : wie abliste bei Eipassmodus zusaetzlich die Aussenabstaende
;** Symbole ausgeben: !abliste2 Liste der Zentrumspunkte der Tonreihe mit den
;**                 :           tiefsten T"nen
;** Ausgabewert     : 

(defun gkons0 (gkons0_liste tonablauf einpass / p1 p2 p3 p4 p5 p6 p7 p8 d h lb l1 
              zaehler1 abliste1 cmd_echo
              zaehler2 startpkt winkel abstan txtsize attrf b-name tf au_prec
              blip_mode os_mode text_style appliname  pos tonliste0 c_layer
              werte ton entityn objli objli1 eedli aws3 ce_color ref1 obj3
              sort_ents)
              ;abliste2 aws3
  (f-gkons01)             
  (setq cmd_echo (getvar "CMDECHO"))
  (setvar "CMDECHO" 0)
  (setq sort_ents (getvar "SORTENTS"))
  (setvar "SORTENTS" 1)
  (command "_undo" "gruppe")
  (setq appliname "MENSUR-KUT224172007")
  (regapp appliname)                 
  (graphscr)
  (setq au_prec (getvar "AUPREC"))
  (setvar "AUPREC" 2) 
  (setq blip_mode (getvar "BLIPMODE"))
  (setvar "BLIPMODE" 0)
  (setq os_mode (getvar "OSMODE"))
  (setvar "OSMODE" 0)
;;;  (setq ce_color (getvar "CECOLOR"))
;;;  (command "farbe" "vonlayer")
  (setq text_style (getvar "TEXTSTYLE"))
  (setvar "MIRRTEXT" 0)
  
  
;** Einpassmodus, 1. und letzter Wert der Liste sind die Aussenabstaende   **
;** Sie werden aus der Liste extrahiert und fuer das Einpassen gespeichert **
   ;(print gkons0_liste)
   (if einpass (setq abliste1 (cdr neuabliste)) (setq abliste1 abliste))
   ;(print abliste)
   ;(print abliste1)  
  
;**Abfrage nach Startpunkt und Richtung
   

  (if (null tonablauf)
    (progn
      (setq startpkt (getpoint "Startpunkt eingeben :  "))
      (setq winkel (getorient startpkt  "Zweiten Punkt eingeben :  "))
      (if (or (<= winkel (* PI (/ 90 180.0)))(>= winkel (* PI (/ 270 180.0))))
	(setq winkel 0)
	(setq winkel PI)
      )	
      (if einpass
        (setq startpkt 
          (list (+ (car startpkt) (car neuabliste)) (cadr startpkt)))
      )
    )
  )

  (setq zaehler1 -1)
  (setq zaehler2 0) 
  
;** Anfangswert der Liste fr Zentrumspunkte der Pfeifen, beginnt mit dem 
;** Durchmesser des tiefsten Tones, wird nur beim 1. Durchlauf erstellt
  (if (null tonablauf)
    (progn  
      (setq abliste2 (list (atof (substr (car gkons0_liste) 11 5))));** Pfeifentiefe
      (if (= 0 (car abliste2))                         ;** Pfeifendurchmesser
        (setq abliste2 (list (atof (substr (car gkons0_liste) 5 5))))
      )
    )
  )
  
  
;** Beginn der Schleife

  (f-gkons02)             
  (repeat (length gkons0_liste)
    (setq zaehler1 (1+ zaehler1))
    (setq zaehler2 (1+ zaehler2)) 
    
;** Auslesen der Werte aus der Liste !liste

    (setq werte (nth zaehler1 gkons0_liste))
    (setq ton (substr werte 1 3))         ;Tonname    
    (setq d (atof (substr werte 5 5)))    ;Durchmesser
    (setq tf (atof (substr werte 11 5)))  ;Pfeifentiefe
;;;    (setq lb (atof (substr werte 22 5)))  ;Labiumbreite
    (setq lb (atof (substr werte 49 5)))  ;Labiumbreite
    (setq hst (atof (substr werte 22 5)))  ;Holzstrke
    (setq vsl (atof (substr werte 27 5)))  ;Vorschlag
    (setq sbrt (atof (substr werte 32 5)))  ;Seitenbart
    (setq fd (atof (substr werte 37 5)))  ;Fussdurchmesser
    (setq fb (atof (substr werte 43 5)))  ;Fussbreite
    
;** Auslesen der Abstnde (Bsp 7 Pfeifen nur 6 Abstnde)  
    
    (if (< zaehler1 (length abliste1)) (setq abstan (nth zaehler1 abliste1)))
    
    
;** Position des Tonnamen in der !tonliste, fr die Reihenfolge der Toene in 
;** Stueckliste

     (setq tonliste0
       (quote ("C  " "Cs " "D  " "Ds " "E  " "F  " "Fs " "G  " "Gs " "A  " 
         "B  " "H  " "c  " "cs " "d  " "ds " "e  " "f  " "fs " "g  " "gs "
         "a  " "b  " "h  " "c1 " "cs1" "d1 " "ds1" "e1 " "f1 " "fs1" "g1 "
         "gs1" "a1 " "b1 " "h1 " "c2 " "cs2" "d2 " "ds2" "e2 " "f2 " "fs2"
         "g2 " "gs2" "a2 " "b2 " "h2 " "c3 " "cs3" "d3 " "ds3" "e3 " "f3 "
         "fs3" "g3 " "gs3" "a3 " "b3 " "h3 " "c4 " "cs4" "d4 " "ds4" "e4 "
         "f4 " "fs4" "g4 " "gs4" "a4 " "b4 " "h4 ")))

    (setq pos (length (member ton (reverse tonliste0))))
    (setq c_layer (getvar "CLAYER"))

    (setq grad270 (/ (* pi 3) 2))  
;**Holzpfeife Breite und Tiefe, (Rechteck)
;**Holz
;**Holz
;**Holz

    (if (> tf 0)
      (progn
        (f-gkons03)
        (if (null tonablauf)
          (progn
             ;startpkt wird nach oben hin korrigiert, damit die Pfeifengrundrisse
             ;oben bndig gezeichnet werden
             
             (if (null d_alt)
                (setq d_alt (* 2 d))
             )
;;;             (setq startpkt (polar startpkt (/ pi 2) (/ (- d_alt d) 2)))
             
;;;             (setq p1 (polar startpkt winkel (/ tf 2)))
          );progn
          (progn
             (setq p1 (list (car (nth  zaehler2 abliste2)) 
                     (+ (cadr (nth zaehler2 abliste2))(* 2 tonablauf (car abliste2))))
             )
          )
        )
        (setq p11 (polar startpkt winkel (/ tf 2)))
        (setq p1 (polar p11 (/ (* pi 3) 2) (/ d 2)))             
        (setq p2 (polar p1 (/ pi 2) (/ d 2)))
        
        (setq p4 startpkt)
        (setq p3 (polar p4 winkel tf))
        (setq p5 (polar p4 (/ (* pi 3) 2) d))  
        (setq p6 (polar p5 winkel tf))
;;;        (setq p3 (polar p2 0 (/ tf 2)))
;;;        (setq p4 (polar p3 pi tf))
;;;        (setq p5 (polar p4 (/ (* pi 3) 2) d))  
;;;        (setq p6 (polar p5 0 tf))

        (setq p15 (polar p5 (/ (* pi 3) 2) (- vsl hst)))
        (setq p16 (polar p15 winkel tf))
        (setq p25 (polar p15 grad270 sbrt)) 
        (setq p26 (polar p16 grad270 sbrt))
        (set_layer "PF-GRUNDRISS" 7)
        (command "plinie" p3 p4 p5 p6 "s");PF-GRUNDRISS
        (setq obj3 (entlast))
        (if (> hst 0.0)(command "_offset" hst obj3 p1 ""))
        (set_layer "PF-VORSCHLAG" 15)
        (command "plinie" p5 p15 p16 p6 "");PF-VORSCHLAG
        (if (> sbrt 0)
           (if (> (distance p15 p26) 0);Seitenbart
              (progn
                 (set_layer "PF-BART" 252)
                 (command "_line" p15 p25 "")
                 (command "_line" p16 p26 "")
              )
           )
        )
;;;        (if (> (distance p15 p26) 0);Seitenbart
;;;           (progn
;;;              (set_layer "PF-BART" 252)
;;;              (command "_line" p15 p25 "")
;;;              (command "_line" p16 p26 "")
;;;           )
;;;        )        (set_layer "PF-FUSS" 92)
        
;;;        (if (= 0 fb)(command "_circle" p1 "_d" fd))
        
;;;        (if (and (= 0.0 fb) (> fd 0))(command "_circle" p1 "_d" fd))
;;;;;;        (if (and (= 0.0 fb)(> fd 0))(command "_circle" p1 "_d" fd))

        
;;;Fudurchmesser  Holz Rechteck      
;;;        (if (and (> fb 0.0) (> fd 0.0))
;;;           (progn
;;;              (setq p100 (list (+ (car p1) (/ fd 2)) (- (cadr p1) (/ fb 2))))
;;;              (setq p300 (list (- (car p1) (/ fd 2)) (+ (cadr p1) (/ fb 2))))
;;;              (set_layer "PF-FUSS" 92)
;;;              (command "_rectangle" p100 p300)
;;;           )
;;;        )
;;;;;;Fudurchmesser  Holz Rechteck      
;;;        (if (and (> fb 0.0) (> fd 0.0))
;;;           (progn
;;;              (setq p100 (list (+ (car p1) (/ fb 2)) (- (cadr p1) (/ fd 2))))
;;;              (setq p300 (list (- (car p1) (/ fb 2)) (+ (cadr p1) (/ fd 2))))
;;;              (set_layer "PF-FUSS" 92)
;;;              (command "_rectangle" p100 p300)
;;;           )
;;;        )
        
;;;        (if (and (= 0.0 fb) (> fd 0))(command "_circle" p1 "_d" fd))

        (setq ref1 "0")
      )
;Ende Holz      
      
;**Metallpfeife Durchmesser, (Kreis)    
;**Metall
;**Metall
;**Metall       
      (progn
        (f-gkons04)
        (if (null tonablauf)
          (progn
            (setq p1 (polar startpkt winkel (/ d 2)))
          );progn
          (progn
            (setq p1 (list (car (nth  zaehler2 abliste2)) 
              (+ (cadr (nth zaehler2 abliste2)) 
              (* 2 tonablauf (car abliste2))))
            )
          );progn
        );if
        (setq h (sqrt (abs (- (expt (/ d 2) 2) (expt (/ lb 2) 2)))))
        (setq p2 (polar p1 (/ (* pi 3) 2) h))
        (setq p3 (polar p2 0 (/ lb 2)))
        ;;;        (setq p3 (polar p2 winkel (/ lb 2)))
        (setq p4 (polar p2 pi (/ lb 2)))   

        (set_layer "PF-GRUNDRISS" 7)    ;**  Pfeifendurchmesser
        (command "_circle" p1 "d" d)    
        (setq obj3 (entlast))

        (set_layer "PF-LABIUM" 252)     ;**  Labium
        (command "linie" p4 p3 "") 

        (setq ref1 (cdr (assoc 5 (entget (entlast))))) ;** Referenz des Labium-
        (setq p24 (polar p4 grad270 sbrt))             ;** striches
        (setq p23 (polar p3 grad270 sbrt))
        (if (> (distance p4 p24) 0)
          (progn
            (set_layer "PF-BART" 252)
            (command "linie" p4 p24 "")
            (setq ref_b1 (cdr (assoc 5 (entget (entlast))))) ;** Referenz Bart1
            (command "linie" p3 p23 "")
            (setq ref_b2 (cdr (assoc 5 (entget (entlast))))) ;** Referenz Bart2
          )
          (setq ref_b1 ref1 ref_b2 ref1)
        )
;;;        ;;;Fudurchmesser        
;;;        (if (and (= 0.0 fb)(> fd 0))
;;;          (progn
;;;            (set_layer "PF-FUSS" 92)
;;;            (command "_circle" p1 "_d" fd)
;;;          )
;;;        )
      );progn Metall Pfeife
       
;Ende **Metall
       
    );if


;;;Fudurchmesser  fr Holz und Metall
     
        (if (and (= 0.0 fb)(> fd 0))
          (progn
            (set_layer "PF-FUSS" 92)
            (command "_circle" p1 "_d" fd)
          )
        )

        (if (and (> fb 0.0) (> fd 0.0))
           (progn
              (setq p100 (list (+ (car p1) (/ fb 2)) (- (cadr p1) (/ fd 2))))
              (setq p300 (list (- (car p1) (/ fb 2)) (+ (cadr p1) (/ fd 2))))
              (set_layer "PF-FUSS" 92)
              (command "_rectangle" p100 p300)
           )
        )




     
 ;** EED-Daten (Die Reihenfolge der Eintraege darf nicht veraendert werden,
 ;**            da sie mit (nth n ...) ausgelesen werden, nur anhaengen!!
  (f-gkons05)     
  ;(break)        
  (setq objli (entget obj3))
  (setq objli1 (reverse objli))
  (if ref_b1
     (setq eedli (list -3 (list appliname 
                         (cons 1000 "EINGABE") 
                         (cons 1000 gstring);**Grundriss-Eingaben
                         (cons 1000 "WERTE") 
                         (cons 1000 werte)  ;**Koerperlaenge,Durchmesser,Labium
                         (cons 1000 "A-EINGABE") 
                         (cons 1000 "leer") ;**Ansicht-Eingaben
                         (cons 1005 "0")    ;**Referenz der EEDinfo-Linie
                         (cons 1070 pos)    ;**Stelle des Tons in !tonliste
                         (cons 1005 ref1)   ;**Referenz des Labiumstrichs im G
                         (cons 1011 p4)    ;**Startpunkt des Labiumstrichs im G
                         (cons 1011 p3)    ;**Endpunkt des Labiumstrichs im G
                         (cons 1005 ref_b1)   ;**Referenz des Labiumstrichs im G
                         (cons 1005 ref_b2)   ;**Referenz des Labiumstrichs im G                                
                         )))
     (setq eedli (list -3 (list appliname 
                         (cons 1000 "EINGABE") 
                         (cons 1000 gstring);**Grundriss-Eingaben
                         (cons 1000 "WERTE") 
                         (cons 1000 werte)  ;**Koerperlaenge,Durchmesser,Labium
                         (cons 1000 "A-EINGABE") 
                         (cons 1000 "leer") ;**Ansicht-Eingaben
                         (cons 1005 "0")    ;**Referenz der EEDinfo-Linie
                         (cons 1070 pos)    ;**Stelle des Tons in !tonliste
                         (cons 1005 ref1)   ;**Referenz des Labiumstrichs im G
                         (cons 1011 p4)    ;**Startpunkt des Labiumstrichs im G
                         (cons 1011 p3)    ;**Endpunkt des Labiumstrichs im G
                         )))
  );if
  (setq objli1 (cons eedli objli1))
  (setq objli (reverse objli1))
  (entmod objli)  

;**mittenkreuz + text
     
     (f-gkons06)              
     (setq p5 (polar p1 (/ pi 2) (/ d 20)))
     (setq p6 (polar p5 (* (/ pi 2) 3) (/ d 10)))
     (setq p7 (polar p1 0 (/ d 20)))
;;;     (setq p7 (polar p1 winkel (/ d 20)))
     (setq p8 (polar p7 pi (/ d 10)))
     (set_layer "PF-MITTE" 252)
     (command "linie" p5 p6 "")
     (command "linie" p7 p8 "")
     (set_layer "PF-TEXT" 252)
     (command "text" "z" (polar p1 (/ pi 2) (/ d 15))
       (/ d 10) 0 (substr werte 1 3))
     (set_layer c_layer 0)
     (command "_undo" "ende")
     
;**neuer Startpunkt fr nchste Pfeife wenn Tonablauf > 1

     (if (null tonablauf)
       (progn
         (f-gkons07)              
         (if (> tf 0)
           (setq startpkt (polar startpkt winkel (+ abstan tf)))
           (setq startpkt (polar startpkt winkel (+ abstan d)))
         ) 
         (setq abliste2 (cons p1 abliste2))
       )
     )
     (setq d_alt d)
     
  );ende repeat
  (if (null tonablauf)(setq abliste2 (reverse abliste2)))
  (setvar "AUPREC" au_prec)
  (setvar "BLIPMODE" blip_mode)
  (setvar "OSMODE" os_mode)
;;;  (command "farbe" ce_color)
  (command "stil" text_style "" "" "" "" "" "" "")
  (setvar "CMDECHO" cmd_echo)
  (setvar "SORTENTS" sort_ents)
  ; (print abliste2)
  (princ)
  (f-gkons08)              
  (quit)
)
  
  
;** Funktion setzt den bergebenen Layer, legt neuen an wenn es ihn
;** noch nicht gibtund stellt die Farbe des Layers ein
;** lay - Name des Layers
;** fa  - Farbe des Layers
  
 (defun set_layer (lay fa / da la)
   (setq la (getvar "clayer"))
   (setq da (tblsearch "layer" lay))
   (if (not da)
     (command "layer" "ma" lay "se" lay "")
     (if (= (logand (cdr (assoc 70 da)) 1) 0) 
       (command "layer" "se" lay "")
       (command "layer" "tau" lay "se" lay "")
     )
   )
   (if (/= fa 0)
     (command "layer" "fa" fa lay "")
   )
 )

  
 
 
 
 

(defun  f-gkons01 ()

  (setq alterror *error*)
;
 (defun *error* (st)
   ;(command "_undo" "e")
   ;(setvar "osmode" 0)
   (princ (strcat "**** FEHLER in gkons0 ****  " st))
   (varreorg) (redraw)
   (setq *error* alterror)
   (princ)
 )
)


(defun f-gkons02 ()

  (setq alterror *error*)
;
 (defun *error* (st)
   ;(command "_undo" "e")
   ;(setvar "osmode" 0)
   (princ (strcat "**** FEHLER in gkons0, repeat1 ****  " st))
   (varreorg) (redraw)
   (setq *error* nil)
   (princ)
 )
)


(defun f-gkons03 ()

  (setq alterror *error*)
;
 (defun *error* (st)
   ;(command "_undo" "e")
   ;(setvar "osmode" 0)
   (princ (strcat "**** FEHLER in gkons0, holz ****  " st))
   (varreorg) (redraw)
   (setq *error* nil)
   (princ)
 )
)


(defun f-gkons04 ()

  (setq alterror *error*)
;
 (defun *error* (st)
   ;(command "_undo" "e")
   ;(setvar "osmode" 0)
   (princ (strcat "**** FEHLER in gkons0, metall ****  " st))
   (varreorg) (redraw)
   (setq *error* nil)
   (princ)
 )
)


(defun f-gkons05 ()

  (setq alterror *error*)
;
 (defun *error* (st)
   ;(command "_undo" "e")
   ;(setvar "osmode" 0)
   (princ (strcat "**** FEHLER in gkons0, eed schreiben ****  " st))
   (varreorg) (redraw)
   (setq *error* nil)
   (princ)
 )
)


(defun f-gkons06 ()

  (setq alterror *error*)
;
 (defun *error* (st)
   ;(command "_undo" "e")
   ;(setvar "osmode" 0)
   (princ (strcat "**** FEHLER in gkons0, text ****  " st))
   (varreorg) (redraw)
   (setq *error* nil)
   (princ)
 )
)


(defun f-gkons07 ()

  (setq alterror *error*)
;
 (defun *error* (st)
   ;(command "_undo" "e")
   ;(setvar "osmode" 0)
   (princ (strcat "**** FEHLER in gkons0, startpkt ****  " st))
   (varreorg) (redraw)
   (setq *error* nil)
   (princ)
 )
)

(defun f-gkons08 ()

  (setq alterror *error*)
;
 (defun *error* (st)
   ;(command "_undo" "e")
   ;(setvar "osmode" 0)
   ;(princ (strcat "**** FEHLER in gkons0, startpkt ****  " st))
   (princ "**** Programmverschachtelung erkannt ****\n")
   
   (varreorg) (redraw)
   (setq *error* nil)
   (princ)
 )
 (princ "OK \n")
)



;************************************************************************************
;************************************************************************************
;************************************************************************************

(defun varreorg ()
  (setvar "CMDECHO" 0)
  (setvar "BLIPMODE" 1)
  ;(setvar "" "")
  ;(setvar "" "")
  ;(setvar "" "")
  ;(setvar "" "")
  ;(setvar "" "")
  ;(setvar "" "")
  (princ)
)


;************************************************************************************
;************************************************************************************
;************************************************************************************

;  VRECH


(defun vrech (zahl strecke start end / abstand step1 step2 step3 step4 zaehler1
                zaehler2 zaehler3 start1 end1 schleife1 wert abstliste
								teilungsrest alteselement zaehler4 zaehler5 cmd_echo)
  
	(setq cmd_echo (getvar "CMDECHO"))
	(setvar "CMDECHO" 0)
  (setq step1 0.05);** Schrittweite fuer Startabstand
  (setq step2 0.05);** Schrittweite fuer Endabstand
	(setq step3 100)  ;** Schrittweite fuer Schnellgang
	(setq step4 0.1)   ;** Schrittweite fuer Startwert des Startabstandes
	(setq zaehler2 1)
	(setq zaehler3 1)
	(setq zaehler5 0)
	(setq start1 start)
	(setq end1 end)
  (setq abstand start)
	(setq strecke (abs (rund strecke 1)))
	(setq wert (* 2 (abs strecke)))   ;** Zuweisung eines Dummy-Wertes
  (setq schleife1 T)


;* Logarithmische Aufteilung des Restabstandes *

;** Randbedingungen sind Start- und Endabstand, ist die Summe der Teile 
;** groesser als der Restabstand werden Start- und Endabstand um die Schritt-
;** weite step1 und step2 verringert. Ist die Differenz der Summe der Teile
;** und des Restabstandes groesser als step3 wird die Schrittweite von step1
;** und step2 ver-10-facht. Der Restabstand kann nicht immer ordnungsgemaess -
;** d.h. die Summe der Teile ist geringer als der Restabstand - aufgeteilt 
;** werden wobei die Genauigkeit 1/10 betraegt. Der verbleibende Teilungsrest
;** wird in 1/10 Schritten auf die errechneten Teile verteilt, beginnend bei
;** dem groessten Teil. Jedem Teil darf nur 1/10 zuaddiert werden um eine Ge-
;** nauigkeit von 1/10 pro Abstand einzuhalten. Ist der Teilungsrest zu gross,
;** wird der Startwert um step4 erhoeht und die Rechnung beginnt von vorn.
;** Wird einer der Teile <= 0 so wir der Startwert um step4 verringert und die
;** Rechnung beginnt von vorn.

	(while schleife1
	  (setq zaehler5 (1+ zaehler5)) ;** zaehlen der Rechendurchlaeufe
		(princ zaehler5)
		(princ " ")
    (setq abstliste '())
  	(setq zaehler1 zahl) ;** soviele Wiederholungen wie Abstaende
  	(repeat zaehler1
		  ;(print start1)
			;(print end1)
			
;** Erzeugung der Liste der Teile 
;** Wenn Start- oder Endabstand <= 0 werden die Abstaende auf 0 gesetzt			
			
  	  (if (or (<= start1 0) (<= end1 0))
  		  (setq abstand 0)
    	  (setq abstand (/ abstand (exp (/ (log (/ start1 end1)) zaehler1))))
  	  )
  		(setq abstliste (cons (rund abstand 1) abstliste));** Aufbau der Liste
			;(print start1)
			;(print end1)
			;(print abstand)
			;(print abstliste)
			;(print strecke)
			;(print wert)
			;(terpri)
  	)
		;** Bedingung fuer Schnellgang s.o.
		
		(if (< step3 (- wert (abs strecke))) (setq fktr 10) (setq fktr 1))
		
		;** Verringerung der Rechenwerte um die Schrittweite
		
		(setq end1 (- end1 (* step2 fktr)))
		(setq start1 (- start1 (* step1 fktr)))
		(setq wert (rund (apply '+ abstliste) 1))
		(cond
		
		;** wenn der Startabstand zu gross ist wird er um step4 verringert
		
		  ((= abstand 0)
			  ;(setq step4 (* step4 zaehler2))
			  (setq abstand (- start (* step4 zaehler2))) 
				(setq start1 (- start (* step4 zaehler2)))
				;(setq end1 (- end (* step4 zaehler2)))
				(setq end1 end)
				(setq zaehler2 (1+ zaehler2))
			)
			
		;** wenn der Startabstand zu gering ist, wird er um 1 erhoeht
		
      ((> (/ (- strecke wert) zahl) 0.1) 
  		  ;(setq step4 (* step4 zaehler3))
			  (setq abstand (+ start (* step4 zaehler3))) 
				(setq start1 (+ start (* step4 zaehler3))) 
				;(setq end1 (+ end (* step4 zaehler3)))
				(setq end1 end)
			  (setq zaehler3 (1+ zaehler3))
			)
			
		;** wenn der Rest genau aufgeteilt wird, Rechnung wird beendet
			
  	  ((= strecke wert)  
			  (setq schleife1 nil) (setq abstliste (reverse abstliste))
			)
			
		;**wenn die Summe der Teile kleiner als der Rest ist, Rechnung wird beendet
		
		  ((< wert strecke)
			  (setq schleife1 nil)
				(princ "\nErechneter Wert entspricht dem Sollwert. ")
				(princ "\nUngenauigkeit der Abstandsoptimierung ist <= ")
				(if (<= (/ (- strecke wert) zahl) 0.1)
				  (princ "0.1")
					(princ (abs (/ (- strecke wert) zahl)))
				)
				(princ " mm pro Abstand")
				(setq teilungsrest (- strecke wert))
			  (setq abstliste (reverse abstliste))
				(setq zaehler4 0)
				(while (> teilungsrest 0)
				  ;(break)
					(setq alteselement (nth zaehler4 abstliste))
					;(print alteselement)
					(setq abstliste  (subst (+ 0.1 alteselement) alteselement abstliste))
					(setq teilungsrest (- teilungsrest 0.1))
					(setq zaehler4 (1+ zaehler4))
				)
			)
		)
	);**schleife1
	(princ 
	  "\nNeue Abstnde : 1. Auenabstand - Zwischenabstnde - 2. Auenabstand")
 	(print abstliste)
	(print (strcat (itoa zaehler5) " Rechnungen wurden durchgefhrt "))
	(princ)
	;(print strecke)
	;(print wert)
	(setvar "CMDECHO" cmd_echo)
	(setq abstliste abstliste)
)





;************************************************************************************
;************************************************************************************
;************************************************************************************


(defun ver3 (/ startpkt aws1 schleife1 schleife2 pkt1 pkt2 zaehler1 zaehler2
               zaehler3 zaehler4 pfentili zahl l eedli cmd_echo os_mode)
  (fehlerver31)              
  (setq cmd_echo (getvar "CMDECHO"))
  (setvar "CMDECHO" 0)
  (setq appliname "MENSUR-KUT224172007")
  (regapp appliname)
  (setq aws1 nil)
  (princ "** Konstruktion der Pfeifenkrper-Ansicht ** ")
  (terpri)
  (princ "Pfeifen whlen ")
  (terpri)
  (setq schleife1 T)
  (setq schleife2 T)
  (while schleife1
    (while schleife2
      (fehlerver32)
      (terpri)
      (command "wahl" "auto" pause)
      (setq aws1 (ssget "_P"))
      (if (null aws1) (print "Kein Objekt gefunden  ") (setq schleife2 nil))
    );**schleife2
    (setq zaehler1 0)
    (setq zaehler2 0)
    (setq zaehler3 0)
    (setq pfentili '())
    (setq zahl (sslength aws1))
;;;    (repeat zahl
;;;       (setq zaehler4
    (fehlerver33)
    (repeat zahl ;repeat1
      (setq l (ssname aws1 zaehler1))
      (setq eedli (entget l (list appliname)))
      (if (and eedli (= "EINGABE" (cdadr (cadr (assoc -3 eedli)))))
        (progn
          (setq zaehler3 (1+ zaehler3))
          (setq pfentili (cons l pfentili))
        )
        (setq zaehler2 (1+ zaehler2))
      );**if
      (setq zaehler1 (1+ zaehler1))
    );**repeat
    
    (if (= zaehler2 zahl) 
      (progn
        (princ "Keine Pfeife gefunden ")
        (terpri)
        (setq schleife2 T)
      )
      (progn
        (setq schleife1 nil)
        (princ zahl)
        (princ " Objekte gewhlt, ")
        (princ zaehler3)
        (princ " Pfeifen gefunden ")
        (terpri)
        (setq os_mode (getvar "OSMODE"))
        (setvar "OSMODE" 512)
        (setq startpkt (getpoint "\nEinfgepunkt : "))
        (setvar "OSMODE" os_mode)
        (setq zaehler4 0)
        (fehlerver34)
        (repeat zaehler3 ;repeat2
          (akons3 (nth zaehler4 pfentili) startpkt zaehler3 zaehler4)
          (setq zaehler4 (1+ zaehler4))
        )
        ;(command "layer" "aus" "EED-INFO" "")        
      )
    )
  )
  (setvar "CMDECHO" cmd_echo)
)
      



(defun fehlerver31 ()

  (setq alterror *error*)
;
 (defun-q *error* (st)
   ;(command "zurck" "e")
   ;(setvar "osmode" 0)
   (princ (strcat "**** FEHLER in ver3, schleife1 ****  " st))
   (varreorg) (redraw)
   (setq *error* nil)
   (princ)
 )
)


(defun fehlerver32 ()

  (setq alterror *error*)
;
 (defun-q *error* (st)
   ;(command "zurck" "e")
   ;(setvar "osmode" 0)
   (princ (strcat "**** FEHLER in ver3, schleife2 ****  " st))
   (varreorg) (redraw)
   (setq *error* nil)
   (princ)
 )
)


(defun fehlerver33 ()

  (setq alterror *error*)
;
 (defun-q *error* (st)
   ;(command "zurck" "e")
   ;(setvar "osmode" 0)
   (princ (strcat "**** FEHLER in ver3, repeat1 ****  " st))
   (varreorg) (redraw)
   (setq *error* nil)
   (princ)
 )
)


(defun fehlerver34 ()

  (setq alterror *error*)
;
 (defun-q *error* (st)
   ;(command "zurck" "e")
   ;(setvar "osmode" 0)
   (princ (strcat "**** FEHLER in ver3, repeat2 ****  " st))
   (varreorg) (redraw)
   (setq *error* nil)
   (princ)
 )
)

(princ)


;************************************************************************************
;************************************************************************************
;************************************************************************************


(defun akons3 (entityli p0 anzahl_ansichten durchlauf_ansichten / au_prec blip_mode os_mode ce_color pd_mode 
                             pd_size schleife1 b appliname cmd_echo sort_ents)
  (f-akons31)                         
  (setq cmd_echo (getvar "CMDECHO"))
  (setvar "CMDECHO" 0)
  (command "_regenauto" "_off")
  (setq sort_ents (getvar "SORTENTS"))
  (setvar "SORTENTS" 1)
  (command "zurck" "gruppe")
  (setq appliname "MENSUR-KUT224172007")
  (setq au_prec (getvar "AUPREC"))
  (setvar "AUPREC" 4) 
  (setq blip_mode (getvar "BLIPMODE"))
  (setvar "BLIPMODE" 0)
  (setq os_mode (getvar "OSMODE"))
  (setvar "OSMODE" 0)
;;;  (setq pd_mode (getvar "PDMODE"))
;;;  (setvar "PDMODE" 4)
;;;  (setq pd_size (getvar "PDSIZE"))
;;;  (setvar "PDSIZE" 0) 
;;;  (setq ce_color (getvar "CECOLOR"))
;;;  (command "farbe" "VONLAYER")
  (setq p2 p0)
  (setq l entityli)
  (setq l1 (entget l))
  (hole-eed l1 l)
  (setq p2 (list (car d-p1) (cadr p2)))
  (zeichne-ansi)
  ;(command "layer" "aus" "EED-INFO" "")
  (schreibe-eed l)
  (setvar "AUPREC" au_prec)
  (setvar "BLIPMODE" blip_mode)
  (setvar "OSMODE" os_mode)
;;;  (command "farbe" ce_color)
;;;  (setvar "PDMODE" pd_mode)
;;;  (setvar "PDSIZE" pd_size)
  (command "zurck" "ende")
  (setvar "CMDECHO" cmd_echo)
  (setvar "SORTENTS" sort_ents)
  
;** Lschen der globalen Variablen  
  
  ;(setq pktlab1 nil pktlab2 nil pktlab3 nil l nil l1 nil ref nil)
  (setq aeingabe nil aeingabe1 nil aeingabe2 nil p2 nil)
);**defun

  
 
;c
;
(defun zeichne-ansi ( / );d fl lb dr sp pi/2 p3 p4 p5 p6 p7 p8 p9 p10 p12 p13
                       ;p14 p15 p16 p17 p18 p19 p21 p22 winkel2 alpha aws1 aws2
                       ;strecke drehwi entityn objli objli1 eedli c_layer obj1
                       ;obj2 obj3 obj4 obj5 obj6 p151 ok)
  (f-akons32)                       
  (setq aws1 nil aws2 nil)                        
  (setq fl (last aliste))
  (setq lb (/ d-lb 2))                ;** Halbe Labiumbreite, Labiumbogen
  (setq dr (/ d-dr 2))                ;** Halber Pfeifendurchmesser
  (setq sp (/ d-lsp 2))               ;** Halbe Aufschnitthoehe
  (setq pi/2 (/ pi 2))

;Fusslnge Start-Ende
;;;durchlauf_ansichten  die wievielte Ansicht gerade erstellt wird
;;;anzahl_ansichten     Anzahl der zu erstellenden Pfeifenansichten
;;;increment		Wert um die 2 nachfolgende Fulngen unterscheiden
;;;fl_start             Startwert Fulnge
;;;fl_ende              Endwert Fulnge
   
;;;   (setq fl_start 1000)
;;;   (setq fl_ende 500)
;;;   (setq fl_start (nth 3 aliste));;StartWert ist mit EndWert vertauscht damit  Bearbeitungsreihenfolge IO ist
;;;   (setq fl_ende (nth 2 aliste));;EndWert ist StartWert vertauscht damit  Bearbeitungsreihenfolge IO ist
   ;(setq increment (/ (- fl_ende fl_start) (1- anzahl_ansichten)))



;;   
;;;   (setq fl_start (nth 3 aliste))
;;;   (setq fl_ende (nth 2 aliste))
;;;	Startwert ist klein (groer Pfeifendurchmesser)
;;;	Startwert ist gro (kleiner Pfeifendurchmesser)   
   (setq fl_start (nth 2 aliste))
   (setq fl_ende (nth 3 aliste))
   
   (if (= 1 anzahl_ansichten)
      (setq increment 0)
      (setq increment (/ (- fl_ende fl_start) (1- anzahl_ansichten)))
   )
   
   (cond
      ((= 0 fl_ende) (setq fl fl_start))
      ((= 0 durchlauf_ansichten) (setq fl fl_start))
      (T (setq fl (+ fl_start (* durchlauf_ansichten increment))) )
   )

;;;   (cond
;;;      ((= 0 fl_start) (setq fl fl_ende))
;;;      ((= 0 durchlauf_ansichten) (setq fl fl_start))
;;;      (T (setq fl (+ fl_start (* durchlauf_ansichten increment))) )
;;;   )
   
  
;* Berechnung der Punkte der Ansichtkontur: p21, p22, p4, p6, p7, p5
;* Berechnung der Punkte des Labiums: 
;* Berechnung der Punkte des Labiumstrichs: 
;* Berechnung der Punkte des Aufschnitts:
  
  (setq drehwi (angle pktlab1 pktlab2))    ;** Scheitelpunkt des Labiumbogen 
  (setq pktlab3 (polar pktlab1 drehwi lb)) ;** (X-Koordinate von pktlab3)
  
;** Punkte fr die Ansicht-Kontur 
  
  (setq p3 (polar p2 (/ pi 2) fl))
  (setq p4 (polar p3 pi dr))
  (setq p5 (polar p3 0 dr)) 
  (setq p6 (polar p4 (/ pi 2) d-kl))
  (setq p7 (polar p5 (/ pi 2) d-kl))
  (setq p8 (polar p3 (+ pi (/ pi 2)) (/ d-lsp 12)))
  (setq p61 (polar p6 0 dr))
  
;** Punkte fr die Labiumkonstruktion

;** Punkte p10, p9, p13, p14, - Startpunkte des Labiumbogens
;** Fall 1 : Grundriss nicht gespiegelt
  
  (if (< (car pktlab1) (car pktlab2))
    (progn
      (setq p9 (list (car pktlab2) (cadr p8)))
      (setq p10 (list (car pktlab1) (cadr p8)))
      (cond
      
;** Fall 1a : Labiumstrich ragt im Grundriss ueber linken Quadranten hinaus
        ((> (cadr pktlab2) (cadr d-p1)) (setq p9 (list (car p5) (cadr p9))))
        
;** Fall 1b : Labiumstrich ragt im Grundriss ueber rechten Quadranten hinaus
        ((> (cadr pktlab1) (cadr d-p1))(setq p10 (list (car p4)(cadr p10))))
      )
    )
    
;** Fall 2 : Grundriss ist gespiegelt

    (progn
      (setq p9 (list (car pktlab1) (cadr p8)))
      (setq p10 (list (car pktlab2) (cadr p8)))
      (cond
      
;** Fall 2a : Labiumstrich ragt im Grundriss ueber rechten Quadranten hinaus
        ((> (cadr pktlab1) (cadr d-p1)) (setq p9 (list (car p5) (cadr p9))))

;** Fall 2b : Labiumstrich ragt im Grundriss ueber linken Quadranten hinaus
        ((> (cadr pktlab2) (cadr d-p1))(setq p10 (list (car p4)(cadr p10))))
      )
    )
  )
  
  (setq p13 (polar p9 (/ pi 2) (+ d-lhg (/ d-lsp 12))))
  (setq p14 (polar p10 (/ pi 2) (+ d-lhg (/ d-lsp 12))))
  (setq p15 (list (+ (car p10) (/ (distance p9 p10) 2))

                    (+ d-lb d-lb d-lsp (cadr p4))))
  (setq p151 (list (car p15) (- (cadr p15) 10))) ;** 2. Punkt der Spiegelachse
  (setq p16 (polar p10 (/ pi 2) (+ sp (/ d-lsp 12))))
  (setq p17 (polar p9 (/ pi 2) (+ sp (/ d-lsp 12))))
  (setq p18 (polar p10 (/ pi 2) (+ d-lsp (/ d-lsp 12))))
  (setq p19 (polar p9 (/ pi 2) (+ d-lsp (/ d-lsp 12))))
  (setq p21 (polar p2 0 (/ lb 6)))
  (setq p22 (polar p2 pi (/ lb 6)))
  
;** Pruefung ob virtuelles Bild gross genug um Labium der goessten Pfeife
;** darzustellen, wenn zu klein, bricht das Programm ab, da der Befehl "Bruch"
;** als Eingabe einen Auswahlsatz erhaelt der nur dann ein Objekt enthaelt, 
;** wenn der obere Labiumbogen komplett auf den aktuelleb Bildschirmausschnitt
;** passt.
 
;        (print p14)
;        (print p13)
  (setq ok nil)
  (cond 
    ((= "R" (car aliste)) (if (and (inside p14) (inside p13)) (setq ok T)))
    ((= "S" (car aliste)) (if (inside p15) (setq ok T)))
  )
  (if (null ok)
    (progn
      (princ "\n**** Labiumbogen pat nicht in den sichtbaren Bildschirmausschnitt **** ")
      ;(command "layer" "aus" "EED-INFO" "")
      (quit)
    )
  )
  
  
    
  (setq c_layer (getvar "clayer"))
  (set_layer "PFA-PROSPEKT_4" 4)
  (f-akons36)                       
  
;** Erstellung der Konstruktionspunkte fr das Labium 
  
  (cond
    ((= "R" (car aliste))
     (progn
       (set_layer "PFA-PROSPEKT_4" 4)
       (command "plinie" p21 p22 p4 p6 p7 p5 "s") ;** Kontur
       (set_layer "PFA-INFO" 1)
       (command "linie" p61 p2 "") ;** EED-Linie
       (setq obj1 (entlast))
       (set_layer "PFA-PROSPEKTLABIUM" 135)
;;;       (command "farbe" "12")
       (command "plinie" p14 p10 "") ;** linke Labiumgerade
       (setq obj2 (entlast))
       (command "plinie" p13 p9 "")  ;** rechte Labiumgerade
       (setq obj3 (entlast))
       (if (> (car p10) (car p9))
          (command "ellipse" p9 p10 lb) ;** unterer Labiumbogen
          (command "ellipse" p10 p9 lb) ;** unterer Labiumbogen
       )
;;;       (if (> (car p10) (car p9))
;;;          (command "bogen" p9 "en" p10 "r" lb) ;** unterer Labiumbogen
;;;          (command "bogen" p10 "en" p9 "r" lb) ;** unterer Labiumbogen
;;;       )
       
       (if (> (car p10) (car p9))
          (command "bruch" p10 p9)
          (command "bruch" p9 p10)
       )
       (setq obj4 (entlast))
;;;       (if (> (car p13) (car p14))
;;;          (command "bogen" p13 "en" p14 "r" lb) ;** oberer Labiumbogen
;;;          (command "bogen" p14 "en" p13 "r" lb) ;** oberer Labiumbogen
;;;       )      
       (if (< (car p13) (car p14))
          (command "ellipse" p14 p13 lb);** oberer Labiumbogen
          (command "ellipse" p13 p14 lb);** oberer Labiumbogen
       )
       (if (< (car p13) (car p14))
          (command "bruch" p13 p14)
          (command "bruch" p14 p13)
       )
       (setq obj5 (entlast))
;;;       (command "pedit" obj2 "v" obj3 obj4 obj5 "" "") ;** Labium ges
       (command "region" obj2 obj3 obj4 obj5 "") ;** Labium ges
;;;       (command "_chprop" "l" "" "layer" "PFA-PROSPEKTLABIUM" "")
;;;       (command "farbe" "VONLAYER")
       (command "linie" p4 p5 "") ;** Labiumstrich
       (setq obj7 (entlast))
       (command "farbe" 4)
       (command "plinie" p16 "b" d-lsp "" p17 "b" 0 0 "") ;** Aufschnitt
       (command "farbe" "VONLAYER")
      (princ)
     );progn
    )
    ((= "S" (car aliste))
    (progn
       (set_layer "PFA-PROSPEKT_4" 4)
       (command "plinie" p21 p22 p4 p6 p7 p5 "s") ;** Kontur
       (set_layer "PFA-INFO" 1)
       (command "linie" p61 p2 "") ;** EED-Linie
       (setq obj1 (entlast))
       (set_layer "PFA-PROSPEKTLABIUM" 135)
;;;       (command "farbe" "12")
       (command "plinie" p18 p10 "") ;** linke Labiumgerade
       (setq obj2 (entlast))
       (command "plinie" p19 p9 "")  ;** rechte Labiumgerade
       (setq obj3 (entlast))
;;;;;;       (if (> (car p10) (car p9))
;;;;;;          (command "bogen" p9 "en" p10 "r" lb) ;** unterer Labiumbogen
;;;;;;          (command "bogen" p10 "en" p9 "r" lb) ;** unterer Labiumbogen
;;;;;;       )      
       (if (> (car p10) (car p9))
          (command "ellipse" p9 p10 lb) ;** unterer Labiumbogen
          (command "ellipse" p10 p9 lb) ;** unterer Labiumbogen
       )
       (if (> (car p10) (car p9))
          (command "bruch" p10 p9)
          (command "bruch" p9 p10)
       )
       
;;;       (command "ellipse" p9 p10 lb) ;** unterer Labiumbogen
;;;       (command "bruch" p9 p10)
       (setq obj4 (entlast))
       (command "bogen" p19 "E" p15 "S" 90) ;** rechte obere Labiumbogenhaelfte
       (setq obj5 (entlast))
       (command "spiegeln" (entlast) "" p15 p151 "") ;** oberer Labiumbogen ges
       (setq obj6 (entlast))
       (command "region" obj2 obj3 obj4 obj5 obj6"") ;** Labium ges
;;;       (command "pedit" obj2 "v" obj3 obj4 obj5 obj6 "" "") ;** Labiumbogen ges
;;;       (command "farbe" "VONLAYER")
       (command "linie" p4 p5 "") ;** Labiumstrich
       (setq obj7 (entlast))
       (command "farbe" 4)
       (command "plinie" p16 "b" d-lsp "" p17 "b" 0 0 "") ;** Aufschnitt
       (command "farbe" "VONLAYER")
    );progn
   )   
  );cond
  
;** EED-Daten fr Fusslaenge und Koerperlaenge an die Assoziationsliste
;** des Elementes Pfeifen-Ansicht anhngen und in der Geo.dat. aktualisieren
;** Ermitteln des Referenznames des Elementes

  (f-akons33)
  (setq objli (entget obj1))
  ;(setq objli (entget obj7));** Assoziationsliste des Elementnamens
  (setq ref (cons 1005 (cdr (assoc 5 objli)))) ;** erzeugen des Punktepaar (1005 . "referenzname")
  (setq objli1 (reverse objli)) ;** Umkehren der Assoliste
  ;** Erzeugung des EED-Eintrags (-3 "MENSUR-224172007" (1000 . "FL+KL") (etc
  (setq eedli (list -3 (list appliname (cons 1000 "FL+KL")
                                                   (cons 1011 p2) 
                                                   (cons 1011 p5) 
                                                   (cons 1011 p7))))
  (setq objli1 (cons eedli objli1)) ;** Zusammensetzen des EED-Eintrags mit der 
  (setq objli (reverse objli1))     ;** Assoliste, 
  (entmod objli)  ;** aktualisieren der neuen Assoliste

;** Lschen der globalen Variblen

  ;(setq d-wi nil d-p1 nil d-dr nil d-kl nil d-lb nil d-lhg nil d-lsp nil)
  (set_layer c_layer 0)
);defun

(defun schreibe-eed (entityna / objli10 objli11 eedli10 eedli11 appli10 appli11
                                appli12 refeed aeingabe01 aeingabe02 astring)
                                ; ref
  (f-akons34)
  ;(break)                                
  (setq astring (strcat (car aliste) " " (cadr aliste) " " (rtos (last aliste) 2 1)))
  (setq objli10 (entget entityna))
  (setq eedli10 (entget entityna (list appliname)))
  (setq appli10 (cadr (assoc -3 eedli10)))
  (setq appli12 (assoc -3 eedli10))
  ;(break)
  (setq refeed (assoc 1005 (cdr appli10)))
  (setq aeingabe (= "A-EINGABE" (cdr (nth 5 appli10))))
  (setq aeingabe1 (cons 1000 "A-EINGABE"))
  (setq aeingabe2 (cons 1000 astring))
  
  (if aeingabe
    (progn
      (setq aeingabe01 (nth 5 appli10))
      (setq aeingabe02 (nth 6 appli10))
      (setq appli10 (subst aeingabe1 aeingabe01 appli10))
      (setq appli10 (subst aeingabe2 aeingabe02 appli10))
    )
    (print "*** A-EINGABE -Beschreibung fehlt in Extended Entity Data  *** ")
  )
  (if refeed
    (setq appli11 (subst ref refeed appli10))
    (print "*** Referenz-Beschreibung fehlt in Extended Entity Data  *** ")
  )
  (setq appli11 (list -3 appli11))
  (setq eedli11 (subst appli11 appli12 eedli10))
  (entmod eedli11)
)
 
(defun hole-eed (assoli entityna  / aufsch l2 attbez wert eedli appli)
  (f-akons35)
  (setq d-p1 (cdr (assoc 10 assoli))) ;** Zentrumspunkt des Kreises
  (setq aufsch (cadr aliste))
  (setq eedli (entget entityna (list appliname)))
  (setq appli (cadr (assoc -3 eedli)))  
  (setq wert (cdr (nth 4 appli)))
  (setq pktlab1 (cdr (nth 10 appli)))
  (setq pktlab2 (cdr (nth 11 appli)))

  (setq d-dr (atof (substr wert  5 5)));** Pfeifendurchmesser
  (setq d-kl (atof (substr wert 17 4)));** Koerperlaenge
  (setq d-lb (atof (substr wert 49 5)));** Labiumbreite
;;;  (setq d-lb (atof (substr wert 22 5)));** Labiumbreite
  (cond                                ;** Aufschnitthoehe
    ((= "1/4" aufsch) (setq d-lsp (/ d-lb 4)))
    ((= "1/3" aufsch) (setq d-lsp (/ d-lb 3)))        
    ((= "1/5" aufsch) (setq d-lsp (/ d-lb 5)))        
  )
  (setq d-lhg (+ d-lb (/ d-lb 2)))     ;** Hoehe des geraden Labiums  

);**defun



;** Funktion setzt den bergebenen Layer, legt neuen an wenn es ihn
;** noch nicht gibt und stellt die Farbe des Layers ein
;** lay - Name des Layers
;** fa  - Farbe des Layers
  
 (defun set_layer (lay fa / da la)
   (setq la (getvar "clayer"))
   (setq da (tblsearch "layer" lay))
   (if (not da)
     (command "layer" "ma" lay "se" lay "")
     (if (= (logand (cdr (assoc 70 da)) 1) 0) 
       (command "layer" "se" lay "")
       (command "layer" "tau" lay "se" lay ""); Layer wird vorher getaut
     )
   )
   (if (/= fa 0)
     (command "layer" "fa" fa lay "")
   )
 )



(defun inside (pkt0 / x_pkt0 y_pkt0 x_min x_max y_min y_max breite ok_inside)
  (setq x_pkt0 (car pkt0))
  (setq y_pkt0 (cadr pkt0))

;**  Maximale und Minimale X- und Y-Werte im aktuellen Ansichtfenster
  
  (setq y_max (+ (cadr (getvar "VIEWCTR")) (/ (getvar "VIEWSIZE") 2)))
  (setq y_min (- y_max (getvar "VIEWSIZE")))
  (setq breite (* (getvar "VIEWSIZE") 
    (/ (car (getvar "SCREENSIZE")) (cadr (getvar "SCREENSIZE")))))
  (setq x_max (+ (car (getvar "VIEWCTR")) (/ breite 2)))                  
  (setq x_min (- (car (getvar "VIEWCTR")) (/ breite 2)))                  
  (if
    (and (< x_min x_pkt0) (> x_max x_pkt0) (< y_min y_pkt0) (> y_max y_pkt0))
    (setq ok_inside T) (setq ok_inside nil)
  )
)



(defun  f-akons31 ()

  (setq alterror *error*)
;
 (defun *error* (st)
   ;(command "zurck" "e")
   ;(setvar "osmode" 0)
   (princ (strcat "**** FEHLER in akons3 ****  " st))
   (varreorg) (redraw)
   (setq *error* nil)
   (princ)
 )
)


(defun f-akons32 ()

  (setq alterror *error*)
;
 (defun *error* (st)
   ;(command "zurck" "e")
   ;(setvar "osmode" 0)
   (princ (strcat "**** FEHLER in akons3, zeichne-ansi ****  " st))
   (varreorg) (redraw)
   (setq *error* nil)
   (princ)
 )
)


(defun f-akons33 ()

  (setq alterror *error*)
;
 (defun *error* (st)
   ;(command "zurck" "e")
   ;(setvar "osmode" 0)
   (princ (strcat "**** FEHLER in akons3, eed-daten ****  " st))
   (varreorg) (redraw)
   (setq *error* nil)
   (princ)
 )
)


(defun f-akons34 ()

  (setq alterror *error*)
;
 (defun *error* (st)
   ;(command "zurck" "e")
   ;(setvar "osmode" 0)
   (princ (strcat "**** FEHLER in akons3, schreibe-eed ****  " st))
   (varreorg) (redraw)
   (setq *error* nil)
   (princ)
 )
)


(defun f-akons35 ()

  (setq alterror *error*)
;
 (defun *error* (st)
   ;(command "zurck" "e")
   ;(setvar "osmode" 0)
   (princ (strcat "**** FEHLER in akons3, hole-eed ****  " st))
   (varreorg) (redraw)
   (setq *error* nil)
   (princ)
 )
)



(defun f-akons36 ()

  (setq alterror *error*)
;
 (defun *error* (st)
   ;(command "ck" "e")
   ;(setvar "osmode" 0)
   (princ (strcat "**** FEHLER in akons3 **** "))
   ;(terpri)
   ;(princ "**** Labiumbogen liegt nicht im sichtbaren Bildschirmausschnitt **** ")
   ;(terpri)
   (princ  st)
   (command)
   (command)
   ;(exit)
;;;   (command "farbe" "vonlayer")
   (set_layer c_layer 0)
   (setq *error* nil)
   (princ)
 )
)




;************************************************************************************
;************************************************************************************
;************************************************************************************

;;;GDREH



(defun c:gdreh (/  aws1 schleife1 schleife2 zaehler1 zaehler2 zaehler3 zaehler4 
                 pfentili zahl l eedli appliname cmd_echo)
  (f-gdreh1)               
  (setq cmd_echo (getvar "CMDECHO"))
  (setvar "CMDECHO" 0)
  (setq appliname "MENSUR-KUT224172007")
  (regapp appliname)
  (setq aws1 nil)
  (princ "** Drehung des Pfeifenkrper-Grundriss ** ")
  (terpri)
  (princ "Pfeifen whlen ")
  (terpri)
  (setq schleife1 T)
  (setq schleife2 T)
  (while schleife1
    (while schleife2
      (f-gdreh2)
      (terpri)
      (command "wahl" "auto" pause)
      (setq aws1 (ssget "_P"))
      
;* 1. Bedingung fr Auswahl,  ist irgendein Objekt gefunden worden
      
      (if (null aws1) (print "Kein Objekt gefunden  ") (setq schleife2 nil))
    );**schleife2
    (setq zaehler1 0)
    (setq zaehler2 0)
    (setq zaehler3 0)
    (setq pfentili '())
    (setq zahl (sslength aws1))
    (f-gdreh3)
    (repeat zahl ;repeat1
      (setq l (ssname aws1 zaehler1))
      (setq eedli (entget l (list appliname)))
      
;* 2. Bedingung fr Auswahl, hat Objekt ein EED mit Wert "EINGABE"      
      
      (if (and eedli (= "EINGABE" (cdadr (cadr (assoc -3 eedli)))))
        (progn
          (setq zaehler3 (1+ zaehler3))
          (setq pfentili (cons l pfentili))
        )
        (setq zaehler2 (1+ zaehler2))
      );**if
      (setq zaehler1 (1+ zaehler1))
    );**repeat
    
    (if (= zaehler2 zahl) 
      (progn
        (princ "Keine drehbare Pfeife gefunden ")
        (terpri)
        (setq schleife2 T)
      )
      (progn
        (setq schleife1 nil)
        (princ zahl)
        (princ " Objekte gewhlt, ")
        (princ zaehler3)
        (princ " drehbare Pfeifen gefunden ")
        (terpri)
        (setq zaehler4 0)
        ;(print zaehler3)
        ;(print pfentili)
        (f-gdreh4)
        (repeat zaehler3 ;repeat2
          ;(print pfentili)
          ;(print (nth zaehler4 pfentili))
          (dreh_ges (nth zaehler4 pfentili))
          (setq zaehler4 (1+ zaehler4))
        );*repeat
        
      );*progn
    );*if
  );*schleife1
  (setvar "CMDECHO" cmd_echo)
  
)
      

(defun dreh (entityna / entilabium zenpkt eedli appli)
  (f-gdreh5)
  (setq zenpkt (cdr (assoc 10 (entget entityna)))) ;* Zentrumspunkt des Kreises
  (setq eedli (entget entityna (list appliname)))
  (setq appli (cadr (assoc -3 eedli)))  
  (setq entilabium  (handent (cdr (nth 9 appli))))   ;* Entityname des Labiumstriches
  ;(print "Drehung angeben : ")


  (if (= 0 pf_drehung)
      ;;;Drehung am Bildschirm bestimmen
    (command "drehen" entityna entilabium "" zenpkt pause)
      ;;;Drehung aus Dialog bernehmen pf_drehung     
    (command "drehen" entityna entilabium "" zenpkt pf_drehung)
  )


);**defun


(defun dreh_ges (entityna / entilabium zenpkt eedli appli)
  (f-gdreh5)
  (setq zenpkt (cdr (assoc 10 (entget entityna)))) ;* Zentrumspunkt des Kreises
  (setq eedli (entget entityna (list appliname)))
  (setq appli (cadr (assoc -3 eedli)))
  (setq aws_d (ssadd))
  (setq aws_d (ssadd (handent (cdr (nth 9 appli))) aws_d))
  (setq aws_d (ssadd (handent (cdr (nth 12 appli))) aws_d))
  (setq aws_d (ssadd (handent (cdr (nth 13 appli))) aws_d))


  (if (= 0 pf_drehung)
      ;;;Drehung am Bildschirm bestimmen
    (command "drehen" entityna aws_d "" zenpkt pause)
      ;;;Drehung aus Dialog bernehmen pf_drehung     
    (command "drehen" entityna aws_d "" zenpkt pf_drehung)
  )


);**defun






;* Fehler Meldungen


(defun f-gdreh1 ()

  (setq alterror *error*)
;
 (defun-q *error* (st)
   ;(command "zurck" "e")
   ;(setvar "osmode" 0)
   (princ (strcat "**** FEHLER in gdreh, schleife1 ****  " st))
   (varreorg) (redraw)
   (setq *error* nil)
   (princ)
 )
)


(defun f-gdreh2 ()

  (setq alterror *error*)
;
 (defun-q *error* (st)
   ;(command "zurck" "e")
   ;(setvar "osmode" 0)
   (princ (strcat "**** FEHLER in gdreh, schleife2 ****  " st))
   (varreorg) (redraw)
   (setq *error* nil)
   (princ)
 )
)


(defun f-gdreh3 ()

  (setq alterror *error*)
;
 (defun-q *error* (st)
   ;(command "zurck" "e")
   ;(setvar "osmode" 0)
   (princ (strcat "**** FEHLER in gdreh, repeat1 ****  " st))
   (varreorg) (redraw)
   (setq *error* nil)
   (princ)
 )
)


(defun f-gdreh4 ()

  (setq alterror *error*)
;
 (defun-q *error* (st)
   ;(command "zurck" "e")
   ;(setvar "osmode" 0)
   (princ (strcat "**** FEHLER in gdreh, repeat2 ****  " st))
   (varreorg) (redraw)
   (setq *error* nil)
   (princ)
 )
)



(defun f-gdreh5 ()

  (setq alterror *error*)
;
 (defun-q *error* (st)
   ;(command "zurck" "e")
   ;(setvar "osmode" 0)
   (princ (strcat "**** FEHLER in gdreh, dreh ****  " st))
   (varreorg) (redraw)
   (setq *error* nil)
   (princ)
 )
)


(princ)

;************************************************************************************
;************************************************************************************
;************************************************************************************

;;;PF_LISTE

;** pflist      : Stcklistenerzeugung aus den Pfeifen zu denen eine Ansicht
;**             : gehoert. Die Pfeifen werden im Grundriss gewhlt. Nur 1 
;**             : Fenster kann aufgespannt werden. Die Stueckliste wird nach
;**             : der aufsteigenden Reihenfolge der Toene erzeugt.
;**             :

(defun pf_liste (/ startpkt aws1 schleife1 schleife2 pkt1 pkt2 zaehler1 zaehler2
              zaehler3 zaehler4 pfentili zahl l l1 einf bl-name eedli dim_zin
              appliname aws1 pkt1 pkt2 tonpos tonposl tonpaar tonpaarl tonreihe
              startpkt1 koabsta miabsta blip_mode ce_color c_layer faktor
              text_style cmd_echo sort_ents)
  (f-pflist1)             
  (setq cmd_echo (getvar "CMDECHO"))
  (setvar "CMDECHO" 0)
  (setq sort_ents (getvar "SORTENTS"))
  (setvar "SORTENTS" 1)
  (setq att_dia (getvar "ATTDIA"))
  (setvar "ATTDIA" 0)
  (graphscr)
  (setq dim_zin (getvar "DIMZIN"))
  (setvar "DIMZIN" 0)
  (setq blip_mode (getvar "BLIPMODE"))
  (setvar "BLIPMODE" 0)
;;;  (setq ce_color (getvar "CECOLOR"))
;;;  (command "farbe" "VONLAYER")
  (setq c_layer (getvar "clayer"))
  (set_layer "PF-LISTE" 0)
  (setq text_style (getvar "TEXTSTYLE"))
  
;**Textstil iso8 mit Zeichensatzdatei iso8.shx wird gesetzt
   
 ;(command "stil" "iso8" "iso8" "" "" "" "" "" "");** cancel, da es ein "REGEN"
                                                  ;** verursacht
  (setq appliname "MENSUR-KUT224172007")
  (regapp appliname)
  (setq aws1 nil)
  (princ "** Erzeugung der Pfeifen-Liste ** ")
  (terpri)
  (princ "Pfeifen whlen ")
  (terpri)
  (setq schleife1 T)
  (setq schleife2 T)
  
;** Pfeifen im Grundriss waehlen mit "k" oder "f" oder einfach picken
;** Wenn kein objekt anfrage wiederholen
;** Wenn Objekt keinen EED-eintrag ber Referenz 1005 faellt es aus der 
;** Liste heraus
  
  (while schleife1
    (while schleife2
      (f-pflist2)             
      (terpri)
      (command "wahl" "auto" pause)
      (princ)
      (setq aws1 (ssget "_P"))
      (if (null aws1) (print "Kein Objekt gefunden  ") (setq schleife2 nil))
    );**schleife2 z15
    (setq zaehler1 0)
    (setq zaehler2 0)
    (setq zaehler3 0)
    (setq pfentili '())
    (setq tonposl '())
    (setq tonpaarl '())
    (setq zahl (sslength aws1))
    (f-pflist3)             
    (repeat zahl
      (setq l (ssname aws1 zaehler1))
      (setq eedli (entget l (list appliname)))
      (if (cadr (assoc -3 eedli ))
        (progn
        
;** Pruefung aud EED-Eintrag Referenz 1005 und ob es zu der Referenz noch ein
;** Objekt existiert (EED-Infolinie)
        
          (if (and
                (entget (handent (cdr (nth 7 (cadr (assoc -3 eedli))))))
                ;(/= "0" (cdr (nth 7 (cadr (assoc -3 eedli)))))
                (= 1005 (car (nth 7 (cadr (assoc -3 eedli)))))
              )
            (progn
            
;** Erzeugung der Tonpositionslisten und Tonpaarlisten
;** Bsp: Ton C steht in !tonliste an 1. Stelle  (1 . "C  ")
;** Tonposition wird bei der Grundrisserzeugung gesetzt, um in der Stueckliste
;** die Toene in aufsteigender Reihenfolge auszugeben unabhaengig in welcher 
;** Reihenfolge sie erzeugt wurden
            
            
              (setq zaehler3 (1+ zaehler3))
              (setq pfentili (cons l pfentili))
              (setq tonpos (cdr (nth 8 (cadr (assoc -3 eedli)))))
              (setq tonpaar (cons tonpos l))
              (setq tonposl (cons tonpos tonposl))
              (setq tonpaarl (cons tonpaar tonpaarl))
            )
            (setq zaehler2 (1+ zaehler2))
          );**if
        );**progn
      );**if
      (setq zaehler1 (1+ zaehler1))
    );**repeat
    
    (if (= 0 zaehler3) ;(= zaehler2 zahl)
      (progn
        (princ "Keine auswertbare Pfeife gefunden ")
        (terpri)
        (setq schleife2 T)
      )
      (progn
      
;** Meldung ueber die gewaehlten Objekte und Abfrage des Einfuegepunktes      
      
        (f-pflist4)             
        (setq schleife1 nil)
        (princ zahl)
        (princ " Objekte gewhlt, ")
        (princ zaehler3)
        (princ " auswertbare Pfeifen gefunden ")
        (terpri)
        (setq startpkt (getpoint "\nEinfgepunt der Liste (links oben): "))
        ;(print zaehler3)
        ;(print pfentili)
        
;** Pfeifen im Auswahlsatz werden nach aufsteigender Reihenfolge sortiert

        (setq tonreihe (sortauf tonposl))
        
        (f-pflist5)             
        (setq zaehler4 0)
        (command "_undo" "gruppe")
        (repeat zaehler3
          ;(print pfentili)
          ;(print (nth zaehler4 pfentili))
          
;** Aufruf des EED-Leseprog. Parameter ist der Entityname der Objekte in
;** aufsteigender Reihenfolge
          
          (setq ton_num (nth zaehler4 tonreihe))
          (setq ton_enti_na (cdr (assoc (nth zaehler4 tonreihe) tonpaarl)))
          (setq ton_paar_loe (cons ton_num ton_enti_na))
          (refent1 (cdr (assoc (nth zaehler4 tonreihe) tonpaarl)))
          (setq tonpaarl (subst '(0 . 0) ton_paar_loe tonpaarl))
          
          (cond 
;** Einziger Durchlauf bei nur einem Element,
;**  _insertn von li-mitte, li-kopf und li-fuss

           ((= 1 zaehler3)
            (progn
              (setq tons ton)
              (setq faktor 20.0)
              (setq kl (rtos kl 2 1))
              (setq koabsta (* 17.0 faktor))
              (setq miabsta (* 4.5 faktor))           
              (setq startpkt1 (list (car startpkt) (- (cadr startpkt) koabsta)))
              (command "_insert" "li-mitte" startpkt1 faktor "" "" ton kl fl)
              (setq startpkt1 (list (car startpkt1) (- (cadr startpkt1) miabsta)))
              (setq ton (strcat tons " - " ton))
              (command "_insert" "li-kopf" startpkt faktor "" "" 
                mensur tonkor basisl labium ton "Werk" "Register")        
              (command "_insert" "li-fuss" startpkt1 faktor "" "")            
            )
           )
          
;** 1. Durchlauf Startpunkt fr li-mitte wird berechnet, Gr"ssenfaktor
;** Abstand zwischen den Bloecken, Startton

           ((= 0 zaehler4)
            (progn
              (setq tons ton)
              (setq faktor 20.0)
              (setq kl (rtos kl 2 1))
              (setq koabsta (* 17.0 faktor))
              (setq miabsta (* 4.5 faktor))           
              
              ;(command "_insert" "li-kopf" startpkt faktor "" "" 
              ;  mensur tonkor basisl labium ton "Werk" "Register")
              (setq startpkt1 (list (car startpkt) (- (cadr startpkt) koabsta)))
              (command "_insert" "li-mitte" startpkt1 faktor "" "" ton kl fl)
              (setq startpkt1 (list (car startpkt1) (- (cadr startpkt1) miabsta)))              
            )
           )
           
;** Einfuegen des li-mitte in den Durchlaeufen zwischen 1. und letztem

           ((< zaehler4 (1- zaehler3))
            (progn
              (setq kl (rtos kl 2 1))
              (command "_insert" "li-mitte" startpkt1 faktor "" "" ton kl fl)
              (setq startpkt1 (list (car startpkt1) (- (cadr startpkt1) miabsta)))
            )
           )
           
;** Letzter Durchlauf, _insertn von li-mitte, li-kopf und li-fuss

           (T
            (progn
              (setq kl (rtos kl 2 1))
              (command "_insert" "li-mitte" startpkt1 faktor "" "" ton kl fl)
              (setq startpkt1 (list (car startpkt1) (- (cadr startpkt1) miabsta)))
              (setq ton (strcat tons " - " ton))
              (command "_insert" "li-kopf" startpkt faktor "" "" 
                mensur tonkor basisl labium ton "Werk" "Register")        
              (command "_insert" "li-fuss" startpkt1 faktor "" "")            
            )
           )
            
            
            
            
          )
          
          (setq zaehler4 (1+ zaehler4))
        );**repeat
        (command "_undo" "ende") 
      );**progn 
    );**if 
  );** schleife1  
  (setvar "DIMZIN" dim_zin)
  (setvar "BLIPMODE" blip_mode)
;;;  (command "farbe" ce_color)
  (set_layer c_layer 0)
  (command "stil" text_style "" "" "" "" "" "" "")
  (setvar "CMDECHO" cmd_echo)
  (setvar "SORTENTS" sort_ents)
  (setvar "ATTDIA" att_dia)

  
;** Loeschen der globalen Symbole 

  (setq fl nil kl nil mensur nil basisl nil tonkor nil labium nil ton nil 
        tons nil)
  (princ)

);**defun





;** refent1    : Auslesen der EED-Daten aus Grundriss-Element und aus
;**            : Ansicht-Element. Die Verbindung wird ueber "Referenzen"
;**            : und Gruppencode "1005" hergestellt. Fusslaenge und Koerperl.
;**            : koennen durch "strecken" des Ansicht-Elementes geaendert werden
;**            :
;** globale Sym: kl, Koerperlaenge;  fl, Fusslaenge     (aus Ansicht-Element)
;**            : labium, Labiumbreite                   (aus Ansicht-Element)
;**            : mensur, Mensurname;  basisl, Basislage (aus Grundriss-Element)
;**            : tonkor, Tonkorrektur;  ton, Tonname    (aus Grundriss-Element)
  
(defun refent1 (elementna / aeingabe eingabe werte entityna ref eedli appliname
                  appli eedli10 appli10 p1 p2 p3 )
                  
                  ; fl kl mensur basisl tonkor labium ton 
                  
  (f-pflist6)             
  (setq appliname "MENSUR-KUT224172007")
  (regapp appliname)
  (setq eedli (entget elementna (list appliname)))
  (if eedli
    (progn 
      (setq appli (cadr (assoc -3 eedli)))
      ;(break)
      (setq ref (cdr (nth 7 appli)))               ;* Referenz der Ansicht
      (setq eingabe (cdr (nth 2 appli)))           ;* String !eingabe Grundriss
      (setq werte (cdr (nth 4 appli)))             ;* String !werte Grundrriss
      (setq aeingabe (cdr (nth 6 appli)))          ;* String !aeingabe Ansicht
      (setq entityna (handent ref))                ;* Entityname der Ansicht
      (setq eedli10 (entget entityna (list appliname)));*Elementlis der Ansicht
      (setq appli10 (cadr (assoc -3 eedli10)))
      (setq p1 (cdr (nth 2 appli10)))  ;* Punkt p21 der Ansicht
      (setq p2 (cdr (nth 3 appli10)))  ;* Punkt p5 der Ansicht
      (setq p3 (cdr (nth 4 appli10)))  ;* Punkt p7 der Ansicht
      ;(break)
      (setq fl (rtos (- (cadr p2) (cadr p1)) 2 1)) ;* Fusslaenge
      (setq kl (- (cadr p3) (cadr p2)))            ;* Koerperlaenge
      (setq mensur (substr eingabe 1 8))
      (setq basisl (substr eingabe 10 6))
      (setq tonkor (substr eingabe 17 3))
      (setq labium (substr aeingabe 3 3))
      (setq ton (substr werte 1 3))
    );**progn
  );**if z
)




;** Sortiert die Zahlen einer Liste in aufsteigender Reihenfolge

(defun sortauf (sortauf_liste / zahl laenge klein sortl restl)
  (f-pflist7)             
  (setq laenge (length sortauf_liste))
  (setq sortl '() restl '())
  (while (< (length sortl) laenge)
    (setq klein (apply 'min sortauf_liste))
    (setq restl '())
    (foreach zahl sortauf_liste
      (if (= klein zahl)
        (setq sortl (cons zahl sortl))
        (setq restl (cons zahl restl))
      )
    )
    (setq sortauf_liste restl)
  )
  ;(princ (reverse sortl))
  (setq sortl (reverse sortl))
)


;** Funktion setzt den bergebenen Layer, legt neuen an wenn es ihn
;** noch nicht gibtund stellt die Farbe des Layers ein
;** lay - Name des Layers
;** fa  - Farbe des Layers
  
 (defun set_layer (lay fa / da la)
   (setq la (getvar "clayer"))
   (setq da (tblsearch "layer" lay))
   (if (not da)
     (command "_layer" "_make" lay "_set" lay "")
     (if (= (logand (cdr (assoc 70 da)) 1) 0) 
       (command "_layer" "_set" lay "")
       (command "_layer" "_thaw" lay "_set" lay "")
     )
   )
   (if (/= fa 0)
     (command "_layer" "_color" fa lay "")
   )
 )






(defun  f-pflist1 ()

  (setq alterror *error*)
;
 (defun-q *error* (st)
   ;(command "_undo" "e")
   ;(setvar "osmode" 0)
   (princ (strcat "**** FEHLER in pflist  schleife1 ****  " st))
   (varreorg) (redraw)
   (setq *error* nil)
   (princ)
 )
)


(defun f-pflist2 ()

  (setq alterror *error*)
;
 (defun-q *error* (st)
   ;(command "_undo" "e")
   ;(setvar "osmode" 0)
   (princ (strcat "**** FEHLER in pflist, schleife2 ****  " st))
   (varreorg) (redraw)
   (setq *error* nil)
   (princ)
 )
)


(defun f-pflist3 ()

  (setq alterror *error*)
;
 (defun-q *error* (st)
   ;(command "_undo" "e")
   ;(setvar "osmode" 0)
   (princ (strcat "**** FEHLER in pflist, repeat1 ****  " st))
   (varreorg) (redraw)
   (setq *error* nil)
   (princ)
 )
)


(defun f-pflist4 ()

  (setq alterror *error*)
;
 (defun-q *error* (st)
   ;(command "_undo" "e")
   ;(setvar "osmode" 0)
   (princ (strcat "**** FEHLER in pflist, _insert ****  " st))
   (varreorg) (redraw)
   (setq *error* nil)
   (princ)
 )
)


(defun f-pflist5 ()

  (setq alterror *error*)
;
 (defun-q *error* (st)
   ;(command "_undo" "e")
   ;(setvar "osmode" 0)
   (princ (strcat "**** FEHLER in pflist, repeat2 ****  " st))
   (varreorg) (redraw)
   (setq *error* nil)
   (princ)
 )
)


(defun f-pflist6 ()

  (setq alterror *error*)
;
 (defun-q *error* (st)
   ;(command "_undo" "e")
   ;(setvar "osmode" 0)
   (princ (strcat "**** FEHLER in pflist, refent1 ****  " st))
   (varreorg) (redraw)
   (setq *error* nil)
   (princ)
 )
)


(defun f-pflist7 ()

  (setq alterror *error*)
;
 (defun-q *error* (st)
   ;(command "_undo" "e")
   ;(setvar "osmode" 0)
   (princ (strcat "**** FEHLER in pflist, sortauf ****  " st))
   (varreorg) (redraw)
   (setq *error* nil)
   (princ)
 )
)


;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

;** Aktualisieren der Pfeifen im Grundriss, d.h.
;** nach Vervielfltigungs-Operationen wie "Kopieren", "Spiegeln", etc
;** stimmt der EED-Referenz-Eintrag des Labiumstriches nicht mehr mit 
;** der neuen Referenz berein.
;** Der Referenzname und die Endpunkte des Labiumstriches werden aktualisiert.
;** Der Tonname wird aktualisiert.



(defun pf_update (/ objli aws1 kreisli linieli textli pkt1 pkt2 zaehler1
                  zaehler2 zaehler3 zaehler4 reflinie appli werte_eed
                 werte_neu cmd_echo textli_sort linieli_sort kreisli_sort
                 linie_teil_li text_teil_li entity_kreis zentrum_pkt radius
                 dummy_teil_li zaehler5 appliname sort_ents x_bas y_bas x_zen
                 y_zen)


;** Auswahl der zu aktualisierenden Objekte und Sortierung nach Kreisen des 
;** Layers "PF-GRUNDRISS", Linien des Layers "PF-LABIUM" , Text des Layers "PF-TEXT"
;** Die gefundenen Objekte werden in Listen gespeichert und verschiedenen
;** Selektierroutinen unterworfen.

  (f-updges01)
  (referenz)
  (setq cmd_echo (getvar "CMDECHO"))
  (setvar "CMDECHO" 0)
  (setq sort_ents (getvar "SORTENTS"))
  (setvar "SORTENTS" 1)
  (setq appliname "MENSUR-KUT224172007")
  (princ "\nPfeifen whlen  ")
  (command "wahl" "auto" pause)
  (setq aws1 (ssget "_P"))
  (setq zaehler1 0)
  (setq kreisli '())
  (setq linieli '())
  (setq linie_teil_li '())
  (setq textli '())
  
  (setq schleife1 T)
  (repeat (sslength aws1) 
    (setq objli (entget (ssname aws1 zaehler1)))
    (cond
    
;** Vorsortierung nach Layername und Objekttyp Kreis
    
      ((and (= "PF-GRUNDRISS" (strcase (cdr (assoc 8 objli))))
            (= "CIRCLE" (cdr (assoc 0 objli))))   
        
;* Eintrag der Werte Zentumspunkt, Radius, Entityname der Objekte in eine Liste
        
        (progn
          (f-updges02)
          (setq kreisli (cons (cdr (assoc 10 objli)) kreisli))
          (setq kreisli (cons (cdr (assoc 40 objli)) kreisli))
          (setq kreisli (cons (cdr (assoc -1 objli)) kreisli))
        )
      )

;** Vorsortierung nach Layername und Objekttyp Linie

      ((and (= "PF-LABIUM" (strcase (cdr (assoc 8 objli))))
            (= "LINE" (cdr (assoc 0 objli))))

;* Eintrag der Werte Startpunkt, Endpunkt, Entityname der Objekte in eine Liste

        (progn
          (f-updges03)
          (setq linie_teil_li '())
          (setq linie_teil_li (cons (cdr (assoc 10 objli)) linie_teil_li))
          (setq linie_teil_li (cons (cdr (assoc 11 objli)) linie_teil_li))
          (setq linie_teil_li (cons (cdr (assoc -1 objli)) linie_teil_li))
          (setq linieli (cons (reverse linie_teil_li) linieli))
        )
      )

;** Vorsortierung nach Layername und Objekttyp Text

      ((and (= "PF-TEXT" (strcase (cdr (assoc 8 objli))))
            (= "TEXT" (cdr (assoc 0 objli))))

;* Eintrag der Werte Einfgepunkt rechts, Text, Entityname der Objekte in eine Liste

        (progn
          (f-updges04)
          (setq text_teil_li '())
          (setq text_teil_li (cons (cdr (assoc 11 objli)) text_teil_li))
          (setq text_teil_li (cons (cdr (assoc 1 objli)) text_teil_li))
          (setq text_teil_li (cons (cdr (assoc -1 objli)) text_teil_li))
          (setq textli (cons (reverse text_teil_li) textli))
        )
      )
    );**cond
    (setq zaehler1 (1+ zaehler1))
    
  );**repeat
  (setq kreisli (reverse kreisli))
  (setq linieli (reverse linieli))
  (setq textli (reverse textli))
  
;** Aussortierung der berzhligen Tonnamen aus der Tonnamenliste textli
;** Kriterium ist das der X-Wert des Zentumspunktes des Kreises gleich
;** dem X-Wert des Einfgepunktes des Textes ist und der Text ber dem
;** Zentrumspunkt und innerhalb des Kreises liegt.  
  
  (setq zaehler2 0) ;1. Stelle der Liste
  (setq zaehler3 1) ;2. Stelle der Liste
  (setq zaehler4 2) ;3. Stelle der Liste
  (setq kreisli_sort '())
  (setq textli_sort '())
  (setq linieli_sort '())
  (repeat (/ (length kreisli) 3) ;** /3 da 3 Werte zu 1 Objekt gehoeren
    (f-updges05)
    (setq zentrum_pkt (nth zaehler2 kreisli))
    (setq radius (nth zaehler3 kreisli))
    (setq entity_kreis (nth zaehler4 kreisli))
    
    :** Erzeugung der sortierten Linienliste in Abhngigkeit der Kreisliste
    
    (mapcar
      '(lambda (teil_liste)
        (if (= (rund (nth zaehler3 kreisli) 3)
               (rund (distance (car teil_liste) zentrum_pkt) 3)
               (rund (distance (cadr teil_liste) zentrum_pkt) 3))
          (progn
            (setq dummy_teil_li '((0.0 0.0 0.0) (0.0 0.0 0.0) dummy))
            (setq linieli_sort (cons teil_liste linieli_sort))
            (setq linieli (subst dummy_teil_li teil_liste linieli))
          )
        )
      )linieli
    ): ende mapcar
    
    :** Erzeugung der sortierten Textliste in Abhngigkeit der Kreisliste
    (f-updges06)
    (mapcar
      '(lambda (teil_liste)
         (setq x_zen (abs (rund (car (car teil_liste)) 3)))
         (setq y_zen (abs (rund (cadr (car teil_liste)) 3)))
         (setq x_bas (abs (rund (car zentrum_pkt) 3)))
         (setq y_bas (abs (rund (cadr zentrum_pkt) 3)))
         
        ;** Prfung ob der Text-Basispunkt innerhalb des Radius um den
        ;** Kreis-Zentrumspunkt liegt 
        (if (and (< (abs (- x_bas x_zen)) radius) 
                 (< (abs (- y_bas y_zen)) radius)
            )


          (progn
            (setq dummy_teil_li '((0.0 0.0 0.0) dummy1 dummy2))
            (setq textli_sort (cons teil_liste textli_sort))
            (setq textli (subst dummy_teil_li teil_liste textli))
          )
        )
      )textli
    ); ende mapcar
    (setq zaehler2 (+ zaehler2 3))
    (setq zaehler3 (+ zaehler3 3))
    (setq zaehler4 (+ zaehler4 3))
  ); ende repeat
         
  (setq linieli_sort (reverse linieli_sort))
  (setq textli_sort (reverse textli_sort))
  
  
  
   
  (setq zaehler2 0) ;1. Stelle der Liste, wird um 3 erhht
  (setq zaehler3 1) ;2. Stelle der Liste, wird um 3 erhht
  (setq zaehler4 2) ;3. Stelle der Liste, wird um 3 erhht
  (setq zaehler5 0) ;1. Stelle, wird um 1 erhht
  (repeat (/ (length kreisli) 3) ;** /3 da 3 Werte zu 1 Objekt gehoeren
  
  
;******* Update des Referenzname und  des Start- und Endpunktes *******
;******* des Labiumstriches                                     *******
  
  
;** Austausch der alten Referenz

        (f-updges07)
        (setq reflinie (cdr (assoc 5 (entget 
               (caddr (nth zaehler5 linieli_sort))))))
               
        (update-eed (nth zaehler4 kreisli);** Entityname des Objektes
                     (cons 1005 reflinie);** neuer Referenzname
                                         ;** xdata Liste Bsp.(1005 . "2w")
                     8                ;** Stelle der zu tauschenden xdata Liste
                     appliname)       ;** Applikationsname
      
        (setq dezimal_referenz_labium (hex->dez reflinie))
        (setq hex_referenz_bart1 (dez->hex (1- dezimal_referenz_labium)))
        (setq hex_referenz_bart2 (dez->hex (- dezimal_referenz_labium 2)))

;;;	  hier hex wert der referenz zahl um jeweils um 1 erhhen

        (update-eed (nth zaehler4 kreisli);** Entityname des Objektes
                     (cons 1005 hex_referenz_bart1);** neuer Referenzname
                                         ;** xdata Liste Bsp.(1005 . "2w")
                     12                ;** Stelle der zu tauschenden xdata Liste
                     appliname)       ;** Applikationsname

       (update-eed (nth zaehler4 kreisli);** Entityname des Objektes
                     (cons 1005 hex_referenz_bart2);** neuer Referenzname
                                         ;** xdata Liste Bsp.(1005 . "2w")
                     11                ;** Stelle der zu tauschenden xdata Liste
                     appliname)       ;** Applikationsname    

    
;** Austausch des alten Startpunktes des Labiumstriches
      
       (f-updges08)
        (update-eed (nth zaehler4 kreisli);** Entityname des Objektes
                     (cons 1011 (car (nth zaehler5 linieli_sort))) ;** neuer Startpunkt 
                                                        ;** xdata Liste
                     9                ;** Stelle der zu tauschenden xdata Liste
                     appliname)       ;** Applikationsname
      
;** Austausch des alten Endpunktes des Labiumstriches

        (update-eed (nth zaehler4 kreisli);** Entityname des Objektes
                     (cons 1011 (cadr (nth zaehler5 linieli_sort))) ;** neuer Endpunkt
                                                        ;** xdata Liste
                     10               ;** Stelle der zu tauschenden xdata Liste
                     appliname)       ;** Applikationsname


;**** Update des Tonnamen ****

        (f-updges09)
        (setq appli 
          (cadr (assoc -3 (entget (nth zaehler4 kreisli) (list appliname)))))
        (setq werte_eed (cdr (nth 3 (cdr appli))))
        (setq werte_neu (cons 1000    ;neu xdata-Liste Bsp. (1000 . "D   120 ")
          (strcat (substr (strcat (cadr (nth zaehler5 textli_sort)) "   ") 1 4)
          (substr werte_eed 5))))

        (update-eed (nth zaehler4 kreisli);** Entityname
                     werte_neu ;** neue xdata Liste Bsp.(1000 . "D  120  0 24")
                     3         ;** Stelle der zu tauschenden xdata Liste
                     appliname);** Applikationsname
      
            
    (setq zaehler2 (+ zaehler2 3))
    (setq zaehler3 (+ zaehler3 3))
    (setq zaehler4 (+ zaehler4 3))
    (setq zaehler5 (1+ zaehler5))
    
  );**repeat
  (setvar "CMDECHO" cmd_echo)
  (setvar "SORTENTS" sort_ents)
  (princ)   
);ende defun updges




;**Ersetzt in der EED-Liste der Elementdaten eines Objektes eine Liste an einer
;**bestimmten Stelle durch eine bestimmte neue Liste, Bsp. (1005 . "we2")
;** entityna  : Elementname des Objektes in dessen EED-Liste upgedated wird
;** neu       : Liste mit der upgedated wird
;** platz     : Stelle in der EED-Liste an der upgedated wird
;** appliname : Applikationsname "MENSUR-KUT224172007"

(defun update-eed (entityna neu platz appliname / objli10 objli11 eedli10
                   eedli11 appli10 appli11 appli12 wert_alt zaehler1
                   appli10_neu)

  (f-updges10)
  ; gesamte Objektbeschreibung einschl. der eed-daten
  (setq eedli10 (entget entityna (list appliname))) 
  
  ; nur eed-daten der Objektbeschreibung ohne gruppencode "-3"
  (setq appli10 (cadr (assoc -3 eedli10)))
  
  (setq appli10_neu '())
  (setq zaehler1 0)
  
  ; Zusammenbau der neuen Liste Element fr Element aus der alten Liste, bis
  ; auf die Stelle, an der die neue Liste eingetragen werden soll
  
  (repeat (length appli10)
    (setq wert_alt (nth zaehler1 appli10))
    (if (/= platz (1- zaehler1))
      (setq appli10_neu (cons wert_alt appli10_neu))
      (setq appli10_neu (cons neu appli10_neu))
    )
    (setq zaehler1 (1+ zaehler1))
  ); ende repeat
  
  (setq appli10_neu (reverse appli10_neu)); Neue eed-daten in richtiger Reihen-
                                            folge
  ; komplette alte eed-datenliste "(-3 (eed-daten))"
  (setq appli12 (assoc -3 eedli10))
  
  ; komplette neue eed-datenliste "(-3 (eed-daten))"
  (setq appli11 (list -3 appli10_neu))
  
  ; alte komplette eed-datenliste durch neue komplette eed-datenliste ersetzt
  (setq eedli11 (subst appli11 appli12 eedli10))
  
  ; updaten der Geometriedatenbank mit den neien Daten
  (entmod eedli11)
); ende defun


;** Schaltet die Generierung der Objektreferenzen ein

(defun referenz ()
  (if (= 0 (getvar "HANDLES"))
    (command "referenz" "ein")
  )
)



(defun f-updges01 ()

  (setq alterror *error*)
;
 (defun-q *error* (st)
   ;(command "zurck" "e")
   ;(setvar "osmode" 0)
   (princ (strcat "**** FEHLER in updges,  ****  " st))
   (varreorg) (redraw)
   (setq *error* nil)
   (princ)
 )
)

(defun f-updges02 ()

  (setq alterror *error*)
;
 (defun-q *error* (st)
   ;(command "zurck" "e")
   ;(setvar "osmode" 0)
   (princ (strcat "**** FEHLER in updges, kreisli ****  " st))
   (varreorg) (redraw)
   (setq *error* nil)
   (princ)
 )
)

(defun f-updges03 ()

  (setq alterror *error*)
;
 (defun-q *error* (st)
   ;(command "zurck" "e")
   ;(setvar "osmode" 0)
   (princ (strcat "**** FEHLER in updges, linieli ****  " st))
   (varreorg) (redraw)
   (setq *error* nil)
   (princ)
 )
)

(defun f-updges04 ()

  (setq alterror *error*)
;
 (defun-q *error* (st)
   ;(command "zurck" "e")
   ;(setvar "osmode" 0)
   (princ (strcat "**** FEHLER in updges, textli ****  " st))
   (varreorg) (redraw)
   (setq *error* nil)
   (princ)
 )
)

(defun f-updges05 ()

  (setq alterror *error*)
;
 (defun-q *error* (st)
   ;(command "zurck" "e")
   ;(setvar "osmode" 0)
   (princ (strcat "**** FEHLER in updges, linieli_sort ****  " st))
   (varreorg) (redraw)
   (setq *error* nil)
   (princ)
 )
)

(defun f-updges06 ()

  (setq alterror *error*)
;
 (defun-q *error* (st)
   ;(command "zurck" "e")
   ;(setvar "osmode" 0)
   (princ (strcat "**** FEHLER in updges, textli_sort ****  " st))
   (varreorg) (redraw)
   (setq *error* nil)
   (princ)
 )
)

(defun f-updges07 ()

  (setq alterror *error*)
;
 (defun-q *error* (st)
   ;(command "zurck" "e")
   ;(setvar "osmode" 0)
   (princ (strcat "**** FEHLER in updges, Reff-Tausch ****  " st))
   (varreorg) (redraw)
   (setq *error* nil)
   (princ)
 )
)

(defun f-updges08 ()

  (setq alterror *error*)
;
 (defun-q *error* (st)
   ;(command "zurck" "e")
   ;(setvar "osmode" 0)
   (princ (strcat "**** FEHLER in updges, Lab-Tausch ****  " st))
   (varreorg) (redraw)
   (setq *error* nil)
   (princ)
 )
)

(defun f-updges09 ()

  (setq alterror *error*)
;
 (defun-q *error* (st)
   ;(command "zurck" "e")
   ;(setvar "osmode" 0)
   (princ (strcat "**** FEHLER in updges, Ton-Tausch ****  " st))
   (varreorg) (redraw)
   (setq *error* nil)
   (princ)
 )
)

(defun f-updges10 ()

  (setq alterror *error*)
;
 (defun-q *error* (st)
   ;(command "zurck" "e")
   ;(setvar "osmode" 0)
   (princ (strcat "**** FEHLER in updges, update-eed ****  " st))
   (varreorg) (redraw)
   (setq *error* nil)
   (princ)
 )
)



;** Rundet real-zahlen auf n Nachkommastellen ab. (n=stellen)

(defun rund (zahl stellen)
  (setq dim_zin (getvar "DIMZIN")) 
  (setvar "DIMZIN" 0)
  (setq zahl_rund (atof (rtos zahl 2 stellen)))
  (setvar "DIMZIN" dim_zin)
  (setq zahl_rund zahl_rund)
)


(defun pf_info ( / );appliname eedli appli)
  (setq appliname "MENSUR-KUT224172007");(getstring "Applikationsname eingeben : "))
	(terpri)
	(setq eedli (entget (car (entsel)) (list appliname)))
	(if eedli
  	(setq appli (cadr (assoc -3 eedli)))
  )
)


; Diese Funktion rechnet eine hexadezimale Zahl in eine dezimale Zahl um
; Beispiel fr den Funktionsaufruf: (hex->dez "A2E0F")  -> Ergebnis: 667151
(defun hex->dez (zahl / str_length factor summe)
  (setq summe 0)
  (setq str_length (strlen zahl))
  (repeat str_length
    (setq str_length (strlen zahl))
    (cond
      ((= str_length 1)(setq factor 1))
      ((= str_length 2)(setq factor 16))
      ((= str_length 3)(setq factor 256))
      ((= str_length 4)(setq factor 4096))
      ((= str_length 5)(setq factor 65536))
      ((= str_length 6)(setq factor 1048576))
      ((= str_length 7)(setq factor 16777216))
      ((= str_length 8)(setq factor 268435456))
      ((= str_length 9)(setq factor 4294967296))
    )  
    (setq char (strcase (substr zahl 1 1)))
    (cond
      ((= char "0")(setq value 0))
      ((= char "1")(setq value 1))
      ((= char "2")(setq value 2))
      ((= char "3")(setq value 3))
      ((= char "4")(setq value 4))
      ((= char "5")(setq value 5))
      ((= char "6")(setq value 6))
      ((= char "7")(setq value 7))
      ((= char "8")(setq value 8))
      ((= char "9")(setq value 9))
      ((= char "A")(setq value 10))
      ((= char "B")(setq value 11))
      ((= char "C")(setq value 12))
      ((= char "D")(setq value 13))
      ((= char "E")(setq value 14))
      ((= char "F")(setq value 15))
    )
    (setq summe (+ summe (* value factor)))
    (setq zahl (substr zahl 2 (- (strlen zahl) 1)))
  );end repeat
  summe
)

; Diese Funktion rechnet eine dezimale Zahl in eine hexadezimale Zahl um
; Beispiel fr den Funktionsaufruf: (dez->hex 667151)  -> Ergebnis: "A2E0F"
(defun dez->hex (zahl / factor summe hex_string)
  (setq summe 0)
  (setq hex_string "")
    
  (setq diff (fix (/ zahl 4294967296)))
  (setq hex_string (strcat hex_string (get_hex diff)))
  (setq zahl (- zahl (* diff 4294967296)))
    
  (setq diff (fix (/ zahl 268435456)))
  (setq hex_string (strcat hex_string (get_hex diff)))
  (setq zahl (- zahl (* diff 268435456)))
    
  (setq diff (fix (/ zahl 16777216)))
  (setq hex_string (strcat hex_string (get_hex diff)))
  (setq zahl (- zahl (* diff 16777216)))
    
  (setq diff (fix (/ zahl 1048576)))
  (setq hex_string (strcat hex_string (get_hex diff)))
  (setq zahl (- zahl (* diff 1048576)))
    
  (setq diff (fix (/ zahl 65536)))
  (setq hex_string (strcat hex_string (get_hex diff)))
  (setq zahl (- zahl (* diff 65536)))
    
  (setq diff (fix (/ zahl 4096)))
  (setq hex_string (strcat hex_string (get_hex diff)))
  (setq zahl (- zahl (* diff 4096)))
    
  (setq diff (fix (/ zahl 256)))
  (setq hex_string (strcat hex_string (get_hex diff)))
  (setq zahl (- zahl (* diff 256)))
    
  (setq diff (fix (/ zahl 16)))
  (setq hex_string (strcat hex_string (get_hex diff)))
  (setq zahl (- zahl (* diff 16)))
    
  (setq diff (fix (/ zahl 1)))
  (setq hex_string (strcat hex_string (get_hex diff)))
  (setq zahl (- zahl (* diff 1)))
  (setq hex_string (vl-string-left-trim "0" hex_string))
  hex_string
)


(defun get_hex (dezimal / value)
  (cond
    ((= dezimal 0) (setq value "0"))
    ((= dezimal 1) (setq value "1"))
    ((= dezimal 2) (setq value "2"))
    ((= dezimal 3) (setq value "3"))
    ((= dezimal 4) (setq value "4"))
    ((= dezimal 5) (setq value "5"))
    ((= dezimal 6) (setq value "6"))
    ((= dezimal 7) (setq value "7"))
    ((= dezimal 8) (setq value "8"))
    ((= dezimal 9) (setq value "9"))
    ((= dezimal 10)(setq value "A"))
    ((= dezimal 11)(setq value "B"))
    ((= dezimal 12)(setq value "C"))
    ((= dezimal 13)(setq value "D"))
    ((= dezimal 14)(setq value "E"))
    ((= dezimal 15)(setq value "F"))
  )
  value
)  

